/*     */ package com.netapp.asup.client.serialize.handler;
/*     */ 
/*     */ import com.netapp.asup.client.arma.ARMAObject;
/*     */ import com.netapp.asup.client.arma.data.ARMAObjectInstance;
/*     */ import com.netapp.asup.client.arma.data.ARMAObjectInstanceIterator;
/*     */ import com.netapp.asup.client.helper.StatusCode;
/*     */ import com.netapp.asup.client.helper.XMLHelper;
/*     */ import com.netapp.asup.common.AsupLogger;
/*     */ import com.netapp.asup.exception.ARMAException;
/*     */ import com.netapp.asupdata.client.ARMA.ARMAObjectInstanceImpl;
/*     */ import java.io.ByteArrayOutputStream;
/*     */ import java.io.OutputStream;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collection;
/*     */ import java.util.HashMap;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import javax.xml.stream.FactoryConfigurationError;
/*     */ import javax.xml.stream.XMLOutputFactory;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import javax.xml.stream.XMLStreamWriter;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ObjectViewSerializeHandler
/*     */   implements SerializeHandler
/*     */ {
/*  30 */   private XMLStreamWriter writer = null;
/*     */   
/*  32 */   private String bizKey = null;
/*     */   
/*  34 */   public static AsupLogger logger = AsupLogger.getLogger(ObjectViewSerializeHandler.class);
/*     */   
/*     */ 
/*     */ 
/*     */   public XMLStreamWriter init(OutputStream out, String bizKey, String requestId, String clientId, String responseTime)
/*     */     throws FactoryConfigurationError, XMLStreamException
/*     */   {
/*  41 */     this.bizKey = bizKey;
/*  42 */     ByteArrayOutputStream bout = (ByteArrayOutputStream)out;
/*  43 */     this.writer = XMLHelper.initializeXmlWriter(bout);
/*  44 */     XMLHelper.writeStatusResponseXml(this.writer, requestId, responseTime, clientId, StatusCode.SUCCESS.getValue());
/*     */     
/*  46 */     XMLHelper.writeElement("biz_key", bizKey, this.writer);
/*  47 */     return this.writer;
/*     */   }
/*     */   
/*     */   public XMLStreamWriter init(OutputStream out, String bizKey)
/*     */     throws FactoryConfigurationError, XMLStreamException
/*     */   {
/*  53 */     this.bizKey = bizKey;
/*  54 */     ByteArrayOutputStream bout = (ByteArrayOutputStream)out;
/*  55 */     XMLOutputFactory factory = XMLOutputFactory.newInstance();
/*  56 */     this.writer = factory.createXMLStreamWriter(bout, "UTF-8");
/*  57 */     return this.writer;
/*     */   }
/*     */   
/*     */ 
/*     */   public void before(ARMAObjectInstance instance, String serverUrl)
/*     */     throws FactoryConfigurationError, XMLStreamException, ARMAException
/*     */   {
/*  64 */     ARMAObjectInstanceImpl ins = (ARMAObjectInstanceImpl)instance;
/*  65 */     ARMAObject object = ins.getMetamodelObject();
/*     */     
/*     */ 
/*  68 */     Map<String, String> parentMap = new HashMap();
/*     */     
/*  70 */     Collection<String> parentNames = object.getParentNames();
/*  71 */     ARMAObjectInstanceImpl obj = null;
/*  72 */     Utf8 attrVal = null;
/*     */     
/*     */ 
/*  75 */     for (String parentName : parentNames)
/*     */     {
/*     */       try {
/*  78 */         obj = (ARMAObjectInstanceImpl)instance.getParentInstance(parentName);
/*     */       }
/*     */       catch (ARMAException arm) {
/*  81 */         logger.warn(null, "Non mandatory relation:" + parentName, arm); }
/*  82 */       continue;
/*     */       
/*     */ 
/*  85 */       if ((obj != null) && ((obj == null) || (obj.getAttributes().size() != 0)))
/*     */       {
/*     */ 
/*     */ 
/*  89 */         attrVal = obj.getInstanceKey();
/*  90 */         parentMap.put(parentName, attrVal.toString());
/*     */       } }
/*  92 */     XMLHelper.writeParents(this.writer, parentMap, this.bizKey, serverUrl);
/*     */   }
/*     */   
/*     */   public void after(ARMAObjectInstance instance, String serverUrl)
/*     */     throws XMLStreamException
/*     */   {
/*  98 */     Map<Utf8, List<Utf8>> childMap = new HashMap();
/*  99 */     ARMAObjectInstanceImpl ins = (ARMAObjectInstanceImpl)instance;
/*     */     
/* 101 */     ARMAObject metaObj = ins.getMetamodelObject();
/*     */     
/* 103 */     Collection<String> childNames = metaObj.getChildNames();
/* 104 */     ARMAObjectInstanceIterator insIterator = null;
/*     */     
/* 106 */     ARMAObjectInstanceImpl obj = null;
/* 107 */     Utf8 childInstanceKey = null;
/* 108 */     List<Utf8> instanceKeys = null;
/*     */     
/* 110 */     for (String childName : childNames)
/*     */     {
/*     */       try {
/* 113 */         insIterator = instance.getChildInstances(childName);
/*     */       }
/*     */       catch (ARMAException arm) {
/* 116 */         logger.warn(null, "Non mandatory relation:" + childName, arm); }
/* 117 */       continue;
/*     */       
/* 119 */       while (insIterator.hasNext())
/*     */       {
/*     */ 
/* 122 */         obj = (ARMAObjectInstanceImpl)insIterator.next();
/* 123 */         childInstanceKey = obj.getInstanceKey();
/* 124 */         instanceKeys = (List)childMap.get(childName);
/* 125 */         if (instanceKeys == null) {
/* 126 */           instanceKeys = new ArrayList();
/* 127 */           instanceKeys.add(childInstanceKey);
/* 128 */           childMap.put(new Utf8(childName), instanceKeys);
/*     */         }
/*     */         else {
/* 131 */           instanceKeys.add(childInstanceKey);
/*     */         }
/*     */       }
/*     */     }
/*     */     
/* 136 */     XMLHelper.writeChildren(this.writer, childMap, this.bizKey, serverUrl);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\client\serialize\handler\ObjectViewSerializeHandler.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */