/*     */ package com.sun.xml.bind.v2.model.impl;
/*     */ 
/*     */ import com.sun.istack.NotNull;
/*     */ import com.sun.xml.bind.annotation.XmlLocation;
/*     */ import com.sun.xml.bind.api.AccessorException;
/*     */ import com.sun.xml.bind.v2.ClassFactory;
/*     */ import com.sun.xml.bind.v2.model.annotation.AnnotationReader;
/*     */ import com.sun.xml.bind.v2.model.annotation.Locatable;
/*     */ import com.sun.xml.bind.v2.model.core.PropertyKind;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeClassInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeElement;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeNonElement;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimePropertyInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeValuePropertyInfo;
/*     */ import com.sun.xml.bind.v2.runtime.Location;
/*     */ import com.sun.xml.bind.v2.runtime.Name;
/*     */ import com.sun.xml.bind.v2.runtime.Transducer;
/*     */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor.FieldReflection;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor.GetterOnlyReflection;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor.GetterSetterReflection;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor.ReadOnlyFieldReflection;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor.SetterOnlyReflection;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.TransducedAccessor;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext;
/*     */ import java.io.IOException;
/*     */ import java.lang.annotation.Annotation;
/*     */ import java.lang.reflect.Field;
/*     */ import java.lang.reflect.Method;
/*     */ import java.lang.reflect.Modifier;
/*     */ import java.lang.reflect.Type;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import javax.xml.namespace.QName;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.Locator;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ class RuntimeClassInfoImpl
/*     */   extends ClassInfoImpl<Type, Class, Field, Method>
/*     */   implements RuntimeClassInfo, RuntimeElement
/*     */ {
/*     */   private Accessor<?, Locator> xmlLocationAccessor;
/*     */   private Accessor<?, Map<QName, String>> attributeWildcardAccessor;
/*     */   
/*     */   public RuntimeClassInfoImpl(RuntimeModelBuilder modelBuilder, Locatable upstream, Class clazz)
/*     */   {
/*  51 */     super(modelBuilder, upstream, clazz);
/*     */   }
/*     */   
/*     */   public Method getFactoryMethod() {
/*  55 */     return super.getFactoryMethod();
/*     */   }
/*     */   
/*     */   public final RuntimeClassInfoImpl getBaseClass() {
/*  59 */     return (RuntimeClassInfoImpl)super.getBaseClass();
/*     */   }
/*     */   
/*     */   protected ReferencePropertyInfoImpl createReferenceProperty(PropertySeed<Type, Class, Field, Method> seed)
/*     */   {
/*  64 */     return new RuntimeReferencePropertyInfoImpl(this, seed);
/*     */   }
/*     */   
/*     */   protected AttributePropertyInfoImpl createAttributeProperty(PropertySeed<Type, Class, Field, Method> seed)
/*     */   {
/*  69 */     return new RuntimeAttributePropertyInfoImpl(this, seed);
/*     */   }
/*     */   
/*     */   protected ValuePropertyInfoImpl createValueProperty(PropertySeed<Type, Class, Field, Method> seed)
/*     */   {
/*  74 */     return new RuntimeValuePropertyInfoImpl(this, seed);
/*     */   }
/*     */   
/*     */   protected ElementPropertyInfoImpl createElementProperty(PropertySeed<Type, Class, Field, Method> seed)
/*     */   {
/*  79 */     return new RuntimeElementPropertyInfoImpl(this, seed);
/*     */   }
/*     */   
/*     */   protected MapPropertyInfoImpl createMapProperty(PropertySeed<Type, Class, Field, Method> seed)
/*     */   {
/*  84 */     return new RuntimeMapPropertyInfoImpl(this, seed);
/*     */   }
/*     */   
/*     */ 
/*     */   public List<? extends RuntimePropertyInfo> getProperties()
/*     */   {
/*  90 */     return super.getProperties();
/*     */   }
/*     */   
/*     */   public RuntimePropertyInfo getProperty(String name)
/*     */   {
/*  95 */     return (RuntimePropertyInfo)super.getProperty(name);
/*     */   }
/*     */   
/*     */   public void link()
/*     */   {
/* 100 */     super.link();
/* 101 */     getTransducer();
/*     */   }
/*     */   
/*     */ 
/*     */   public <B> Accessor<B, Map<QName, String>> getAttributeWildcard()
/*     */   {
/* 107 */     for (RuntimeClassInfoImpl c = this; c != null; c = c.getBaseClass()) {
/* 108 */       if (c.attributeWildcard != null) {
/* 109 */         if (c.attributeWildcardAccessor == null)
/* 110 */           c.attributeWildcardAccessor = c.createAttributeWildcardAccessor();
/* 111 */         return c.attributeWildcardAccessor;
/*     */       }
/*     */     }
/* 114 */     return null;
/*     */   }
/*     */   
/* 117 */   private boolean computedTransducer = false;
/* 118 */   private Transducer xducer = null;
/*     */   
/*     */   public Transducer getTransducer() {
/* 121 */     if (!this.computedTransducer) {
/* 122 */       this.computedTransducer = true;
/* 123 */       this.xducer = calcTransducer();
/*     */     }
/* 125 */     return this.xducer;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   private Transducer calcTransducer()
/*     */   {
/* 132 */     RuntimeValuePropertyInfo valuep = null;
/* 133 */     if (hasAttributeWildcard())
/* 134 */       return null;
/* 135 */     for (RuntimeClassInfoImpl ci = this; ci != null; ci = ci.getBaseClass()) {
/* 136 */       for (RuntimePropertyInfo pi : ci.getProperties()) {
/* 137 */         if (pi.kind() == PropertyKind.VALUE) {
/* 138 */           valuep = (RuntimeValuePropertyInfo)pi;
/*     */         }
/*     */         else
/* 141 */           return null;
/*     */       }
/*     */     }
/* 144 */     if (valuep == null)
/* 145 */       return null;
/* 146 */     if (!valuep.getTarget().isSimpleType()) {
/* 147 */       return null;
/*     */     }
/* 149 */     return new TransducerImpl((Class)getClazz(), TransducedAccessor.get(valuep));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   private Accessor<?, Map<QName, String>> createAttributeWildcardAccessor()
/*     */   {
/* 156 */     assert (this.attributeWildcard != null);
/* 157 */     return ((RuntimePropertySeed)this.attributeWildcard).getAccessor();
/*     */   }
/*     */   
/*     */   protected RuntimePropertySeed createFieldSeed(Field field) {
/*     */     Accessor.FieldReflection acc;
/*     */     Accessor.FieldReflection acc;
/* 163 */     if (Modifier.isStatic(field.getModifiers())) {
/* 164 */       acc = new Accessor.ReadOnlyFieldReflection(field);
/*     */     } else {
/* 166 */       acc = new Accessor.FieldReflection(field);
/*     */     }
/* 168 */     return new RuntimePropertySeed(super.createFieldSeed(field), acc);
/*     */   }
/*     */   
/*     */ 
/*     */   public RuntimePropertySeed createAccessorSeed(Method getter, Method setter)
/*     */   {
/*     */     Accessor acc;
/*     */     Accessor acc;
/* 176 */     if (getter == null) {
/* 177 */       acc = new Accessor.SetterOnlyReflection(setter);
/*     */     } else { Accessor acc;
/* 179 */       if (setter == null) {
/* 180 */         acc = new Accessor.GetterOnlyReflection(getter);
/*     */       } else
/* 182 */         acc = new Accessor.GetterSetterReflection(getter, setter);
/*     */     }
/* 184 */     return new RuntimePropertySeed(super.createAccessorSeed(getter, setter), acc);
/*     */   }
/*     */   
/*     */   protected void checkFieldXmlLocation(Field f)
/*     */   {
/* 189 */     if (reader().hasFieldAnnotation(XmlLocation.class, f))
/*     */     {
/*     */ 
/* 192 */       this.xmlLocationAccessor = new Accessor.FieldReflection(f); }
/*     */   }
/*     */   
/*     */   public Accessor<?, Locator> getLocatorField() {
/* 196 */     return this.xmlLocationAccessor;
/*     */   }
/*     */   
/*     */ 
/*     */   static final class RuntimePropertySeed
/*     */     implements PropertySeed<Type, Class, Field, Method>
/*     */   {
/*     */     private final Accessor acc;
/*     */     private final PropertySeed<Type, Class, Field, Method> core;
/*     */     
/*     */     public RuntimePropertySeed(PropertySeed<Type, Class, Field, Method> core, Accessor acc)
/*     */     {
/* 208 */       this.core = core;
/* 209 */       this.acc = acc;
/*     */     }
/*     */     
/*     */     public String getName() {
/* 213 */       return this.core.getName();
/*     */     }
/*     */     
/*     */     public <A extends Annotation> A readAnnotation(Class<A> annotationType) {
/* 217 */       return this.core.readAnnotation(annotationType);
/*     */     }
/*     */     
/*     */     public boolean hasAnnotation(Class<? extends Annotation> annotationType) {
/* 221 */       return this.core.hasAnnotation(annotationType);
/*     */     }
/*     */     
/*     */     public Type getRawType() {
/* 225 */       return (Type)this.core.getRawType();
/*     */     }
/*     */     
/*     */     public Location getLocation() {
/* 229 */       return this.core.getLocation();
/*     */     }
/*     */     
/*     */     public Locatable getUpstream() {
/* 233 */       return this.core.getUpstream();
/*     */     }
/*     */     
/*     */     public Accessor getAccessor() {
/* 237 */       return this.acc;
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   private static final class TransducerImpl<BeanT>
/*     */     implements Transducer<BeanT>
/*     */   {
/*     */     private final TransducedAccessor<BeanT> xacc;
/*     */     
/*     */     private final Class<BeanT> ownerClass;
/*     */     
/*     */ 
/*     */     public TransducerImpl(Class<BeanT> ownerClass, TransducedAccessor<BeanT> xacc)
/*     */     {
/* 253 */       this.xacc = xacc;
/* 254 */       this.ownerClass = ownerClass;
/*     */     }
/*     */     
/*     */     public boolean useNamespace() {
/* 258 */       return this.xacc.useNamespace();
/*     */     }
/*     */     
/*     */     public boolean isDefault() {
/* 262 */       return false;
/*     */     }
/*     */     
/*     */     public void declareNamespace(BeanT bean, XMLSerializer w) throws AccessorException {
/*     */       try {
/* 267 */         this.xacc.declareNamespace(bean, w);
/*     */       } catch (SAXException e) {
/* 269 */         throw new AccessorException(e);
/*     */       }
/*     */     }
/*     */     
/*     */     @NotNull
/*     */     public CharSequence print(BeanT o) throws AccessorException {
/* 275 */       try { CharSequence value = this.xacc.print(o);
/* 276 */         if (value == null)
/* 277 */           throw new AccessorException(Messages.THERE_MUST_BE_VALUE_IN_XMLVALUE.format(new Object[] { o }));
/* 278 */         return value;
/*     */       } catch (SAXException e) {
/* 280 */         throw new AccessorException(e);
/*     */       }
/*     */     }
/*     */     
/*     */     public BeanT parse(CharSequence lexical) throws AccessorException, SAXException {
/* 285 */       UnmarshallingContext ctxt = UnmarshallingContext.getInstance();
/*     */       BeanT inst;
/* 287 */       BeanT inst; if (ctxt != null) {
/* 288 */         inst = ctxt.createInstance(this.ownerClass);
/*     */       }
/*     */       else
/*     */       {
/* 292 */         inst = ClassFactory.create(this.ownerClass);
/*     */       }
/* 294 */       this.xacc.parse(inst, lexical);
/* 295 */       return inst;
/*     */     }
/*     */     
/*     */     public void writeText(XMLSerializer w, BeanT o, String fieldName) throws IOException, SAXException, XMLStreamException, AccessorException {
/* 299 */       if (!this.xacc.hasValue(o))
/* 300 */         throw new AccessorException(Messages.THERE_MUST_BE_VALUE_IN_XMLVALUE.format(new Object[] { o }));
/* 301 */       this.xacc.writeText(w, o, fieldName);
/*     */     }
/*     */     
/*     */     public void writeLeafElement(XMLSerializer w, Name tagName, BeanT o, String fieldName) throws IOException, SAXException, XMLStreamException, AccessorException {
/* 305 */       if (!this.xacc.hasValue(o))
/* 306 */         throw new AccessorException(Messages.THERE_MUST_BE_VALUE_IN_XMLVALUE.format(new Object[] { o }));
/* 307 */       this.xacc.writeLeafElement(w, tagName, o, fieldName);
/*     */     }
/*     */     
/*     */     public QName getTypeName(BeanT instance) {
/* 311 */       return null;
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\impl\RuntimeClassInfoImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */