/*     */ package com.sun.xml.bind.v2.model.impl;
/*     */ 
/*     */ import com.sun.xml.bind.api.impl.NameConverter;
/*     */ import com.sun.xml.bind.v2.model.annotation.AnnotationReader;
/*     */ import com.sun.xml.bind.v2.model.annotation.Locatable;
/*     */ import com.sun.xml.bind.v2.model.core.TypeInfo;
/*     */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*     */ import javax.xml.bind.annotation.XmlRootElement;
/*     */ import javax.xml.bind.annotation.XmlSchema;
/*     */ import javax.xml.bind.annotation.XmlType;
/*     */ import javax.xml.namespace.QName;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ abstract class TypeInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>
/*     */   implements TypeInfo<TypeT, ClassDeclT>, Locatable
/*     */ {
/*     */   private final Locatable upstream;
/*     */   protected final TypeInfoSetImpl<TypeT, ClassDeclT, FieldT, MethodT> owner;
/*     */   protected ModelBuilder<TypeT, ClassDeclT, FieldT, MethodT> builder;
/*     */   
/*     */   protected TypeInfoImpl(ModelBuilder<TypeT, ClassDeclT, FieldT, MethodT> builder, Locatable upstream)
/*     */   {
/*  45 */     this.builder = builder;
/*  46 */     this.owner = builder.typeInfoSet;
/*  47 */     this.upstream = upstream;
/*     */   }
/*     */   
/*     */   public Locatable getUpstream() {
/*  51 */     return this.upstream;
/*     */   }
/*     */   
/*     */   void link() {
/*  55 */     this.builder = null;
/*     */   }
/*     */   
/*     */   protected final Navigator<TypeT, ClassDeclT, FieldT, MethodT> nav() {
/*  59 */     return this.owner.nav;
/*     */   }
/*     */   
/*     */   protected final AnnotationReader<TypeT, ClassDeclT, FieldT, MethodT> reader() {
/*  63 */     return this.owner.reader;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final QName parseElementName(ClassDeclT clazz)
/*     */   {
/*  74 */     XmlRootElement e = (XmlRootElement)reader().getClassAnnotation(XmlRootElement.class, clazz, this);
/*  75 */     if (e == null) {
/*  76 */       return null;
/*     */     }
/*  78 */     String local = e.name();
/*  79 */     if (local.equals("##default"))
/*     */     {
/*  81 */       local = NameConverter.standard.toVariableName(nav().getClassShortName(clazz));
/*     */     }
/*  83 */     String nsUri = e.namespace();
/*  84 */     if (nsUri.equals("##default"))
/*     */     {
/*  86 */       XmlSchema xs = (XmlSchema)reader().getPackageAnnotation(XmlSchema.class, clazz, this);
/*  87 */       if (xs != null) {
/*  88 */         nsUri = xs.namespace();
/*     */       } else {
/*  90 */         nsUri = this.builder.defaultNsUri;
/*     */       }
/*     */     }
/*     */     
/*  94 */     return new QName(nsUri.intern(), local.intern());
/*     */   }
/*     */   
/*     */   protected final QName parseTypeName(ClassDeclT clazz) {
/*  98 */     return parseTypeName(clazz, (XmlType)reader().getClassAnnotation(XmlType.class, clazz, this));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final QName parseTypeName(ClassDeclT clazz, XmlType t)
/*     */   {
/* 113 */     String nsUri = "##default";
/* 114 */     String local = "##default";
/* 115 */     if (t != null) {
/* 116 */       nsUri = t.namespace();
/* 117 */       local = t.name();
/*     */     }
/*     */     
/* 120 */     if (local.length() == 0) {
/* 121 */       return null;
/*     */     }
/*     */     
/* 124 */     if (local.equals("##default"))
/*     */     {
/* 126 */       local = NameConverter.standard.toVariableName(nav().getClassShortName(clazz));
/*     */     }
/* 128 */     if (nsUri.equals("##default"))
/*     */     {
/* 130 */       XmlSchema xs = (XmlSchema)reader().getPackageAnnotation(XmlSchema.class, clazz, this);
/* 131 */       if (xs != null) {
/* 132 */         nsUri = xs.namespace();
/*     */       } else {
/* 134 */         nsUri = this.builder.defaultNsUri;
/*     */       }
/*     */     }
/*     */     
/* 138 */     return new QName(nsUri.intern(), local.intern());
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\impl\TypeInfoImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */