/*     */ package com.sun.xml.bind.v2.runtime;
/*     */ 
/*     */ import com.sun.istack.FinalArrayList;
/*     */ import com.sun.istack.SAXException2;
/*     */ import java.io.IOException;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.Attributes;
/*     */ import org.xml.sax.SAXException;
/*     */ import org.xml.sax.helpers.DefaultHandler;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ final class ContentHandlerAdaptor
/*     */   extends DefaultHandler
/*     */ {
/*  43 */   private final FinalArrayList prefixMap = new FinalArrayList();
/*     */   
/*     */ 
/*     */   private final XMLSerializer serializer;
/*     */   
/*  48 */   private final StringBuffer text = new StringBuffer();
/*     */   
/*     */   ContentHandlerAdaptor(XMLSerializer _serializer)
/*     */   {
/*  52 */     this.serializer = _serializer;
/*     */   }
/*     */   
/*     */   public void startDocument() {
/*  56 */     this.prefixMap.clear();
/*     */   }
/*     */   
/*     */   public void startPrefixMapping(String prefix, String uri) {
/*  60 */     this.prefixMap.add(prefix);
/*  61 */     this.prefixMap.add(uri);
/*     */   }
/*     */   
/*     */   public void startElement(String namespaceURI, String localName, String qName, Attributes atts) throws SAXException
/*     */   {
/*     */     try {
/*  67 */       flushText();
/*     */       
/*  69 */       int len = atts.getLength();
/*     */       
/*  71 */       this.serializer.startElement(namespaceURI, localName, getPrefix(qName), null);
/*     */       
/*  73 */       for (int i = 0; i < len; i++) {
/*  74 */         String qname = atts.getQName(i);
/*  75 */         if (!qname.startsWith("xmlns"))
/*     */         {
/*  77 */           String prefix = getPrefix(qname);
/*     */           
/*  79 */           this.serializer.getNamespaceContext().declareNamespace(atts.getURI(i), prefix, true);
/*     */         }
/*     */       }
/*  82 */       for (int i = 0; i < this.prefixMap.size(); i += 2) {
/*  83 */         String prefix = (String)this.prefixMap.get(i);
/*  84 */         this.serializer.getNamespaceContext().declareNamespace((String)this.prefixMap.get(i + 1), prefix, prefix.length() != 0);
/*     */       }
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*  90 */       this.serializer.endNamespaceDecls(null);
/*     */       
/*  92 */       for (int i = 0; i < len; i++)
/*     */       {
/*  94 */         if (!atts.getQName(i).startsWith("xmlns"))
/*     */         {
/*  96 */           this.serializer.attribute(atts.getURI(i), atts.getLocalName(i), atts.getValue(i)); }
/*     */       }
/*  98 */       this.prefixMap.clear();
/*  99 */       this.serializer.endAttributes();
/*     */     } catch (IOException e) {
/* 101 */       throw new SAXException2(e);
/*     */     } catch (XMLStreamException e) {
/* 103 */       throw new SAXException2(e);
/*     */     }
/*     */   }
/*     */   
/*     */   private String getPrefix(String qname) {
/* 108 */     int idx = qname.indexOf(':');
/* 109 */     String prefix = idx == -1 ? qname : qname.substring(0, idx);
/* 110 */     return prefix;
/*     */   }
/*     */   
/*     */   public void endElement(String namespaceURI, String localName, String qName) throws SAXException {
/*     */     try {
/* 115 */       flushText();
/* 116 */       this.serializer.endElement();
/*     */     } catch (IOException e) {
/* 118 */       throw new SAXException2(e);
/*     */     } catch (XMLStreamException e) {
/* 120 */       throw new SAXException2(e);
/*     */     }
/*     */   }
/*     */   
/*     */   private void flushText() throws SAXException, IOException, XMLStreamException {
/* 125 */     if (this.text.length() != 0) {
/* 126 */       this.serializer.text(this.text.toString(), null);
/* 127 */       this.text.setLength(0);
/*     */     }
/*     */   }
/*     */   
/*     */   public void characters(char[] ch, int start, int length) {
/* 132 */     this.text.append(ch, start, length);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\ContentHandlerAdaptor.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */