/*     */ package com.sun.xml.bind.v2.runtime;
/*     */ 
/*     */ import com.sun.istack.NotNull;
/*     */ import com.sun.xml.bind.Util;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeTypeInfo;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Loader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallerImpl;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext;
/*     */ import java.io.IOException;
/*     */ import java.lang.reflect.InvocationTargetException;
/*     */ import java.lang.reflect.Method;
/*     */ import java.util.Arrays;
/*     */ import java.util.Collection;
/*     */ import java.util.Collections;
/*     */ import java.util.Map;
/*     */ import java.util.logging.Level;
/*     */ import java.util.logging.Logger;
/*     */ import javax.xml.bind.Marshaller;
/*     */ import javax.xml.bind.Unmarshaller;
/*     */ import javax.xml.namespace.QName;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class JaxBeanInfo<BeanT>
/*     */ {
/*     */   protected short flag;
/*     */   private static final short FLAG_IS_ELEMENT = 1;
/*     */   private static final short FLAG_IS_IMMUTABLE = 2;
/*     */   private static final short FLAG_HAS_ELEMENT_ONLY_CONTENTMODEL = 4;
/*     */   private static final short FLAG_HAS_BEFORE_UNMARSHAL_METHOD = 8;
/*     */   private static final short FLAG_HAS_AFTER_UNMARSHAL_METHOD = 16;
/*     */   private static final short FLAG_HAS_BEFORE_MARSHAL_METHOD = 32;
/*     */   private static final short FLAG_HAS_AFTER_MARSHAL_METHOD = 64;
/*     */   private static final short FLAG_HAS_LIFECYCLE_EVENTS = 128;
/*     */   
/*     */   protected JaxBeanInfo(JAXBContextImpl grammar, RuntimeTypeInfo rti, Class<BeanT> jaxbType, QName[] typeNames, boolean isElement, boolean isImmutable, boolean hasLifecycleEvents)
/*     */   {
/*  77 */     this(grammar, rti, jaxbType, typeNames, isElement, isImmutable, hasLifecycleEvents);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected JaxBeanInfo(JAXBContextImpl grammar, RuntimeTypeInfo rti, Class<BeanT> jaxbType, QName typeName, boolean isElement, boolean isImmutable, boolean hasLifecycleEvents)
/*     */   {
/*  84 */     this(grammar, rti, jaxbType, typeName, isElement, isImmutable, hasLifecycleEvents);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected JaxBeanInfo(JAXBContextImpl grammar, RuntimeTypeInfo rti, Class<BeanT> jaxbType, boolean isElement, boolean isImmutable, boolean hasLifecycleEvents)
/*     */   {
/*  91 */     this(grammar, rti, jaxbType, (Object)null, isElement, isImmutable, hasLifecycleEvents);
/*     */   }
/*     */   
/*     */   private JaxBeanInfo(JAXBContextImpl grammar, RuntimeTypeInfo rti, Class<BeanT> jaxbType, Object typeName, boolean isElement, boolean isImmutable, boolean hasLifecycleEvents) {
/*  95 */     grammar.beanInfos.put(rti, this);
/*     */     
/*  97 */     this.jaxbType = jaxbType;
/*  98 */     this.typeName = typeName;
/*  99 */     this.flag = ((short)((isElement ? 1 : 0) | (isImmutable ? 2 : 0) | (hasLifecycleEvents ? 128 : 0)));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 119 */   private LifecycleMethods lcm = null;
/*     */   public final Class<BeanT> jaxbType;
/*     */   private final Object typeName;
/*     */   
/*     */   public final boolean hasBeforeUnmarshalMethod()
/*     */   {
/* 125 */     return (this.flag & 0x8) != 0;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public final boolean hasAfterUnmarshalMethod()
/*     */   {
/* 132 */     return (this.flag & 0x10) != 0;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public final boolean hasBeforeMarshalMethod()
/*     */   {
/* 139 */     return (this.flag & 0x20) != 0;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public final boolean hasAfterMarshalMethod()
/*     */   {
/* 146 */     return (this.flag & 0x40) != 0;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final boolean isElement()
/*     */   {
/* 169 */     return (this.flag & 0x1) != 0;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final boolean isImmutable()
/*     */   {
/* 180 */     return (this.flag & 0x2) != 0;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final boolean hasElementOnlyContentModel()
/*     */   {
/* 190 */     return (this.flag & 0x4) != 0;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final void hasElementOnlyContentModel(boolean value)
/*     */   {
/* 200 */     if (value) {
/* 201 */       this.flag = ((short)(this.flag | 0x4));
/*     */     } else {
/* 203 */       this.flag = ((short)(this.flag & 0xFFFFFFFB));
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean lookForLifecycleMethods()
/*     */   {
/* 214 */     return (this.flag & 0x80) != 0;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract String getElementNamespaceURI(BeanT paramBeanT);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract String getElementLocalName(BeanT paramBeanT);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Collection<QName> getTypeNames()
/*     */   {
/* 263 */     if (this.typeName == null) return Collections.emptyList();
/* 264 */     if ((this.typeName instanceof QName)) return Collections.singletonList((QName)this.typeName);
/* 265 */     return Arrays.asList((QName[])this.typeName);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public QName getTypeName(@NotNull BeanT instance)
/*     */   {
/* 277 */     if (this.typeName == null) return null;
/* 278 */     if ((this.typeName instanceof QName)) return (QName)this.typeName;
/* 279 */     return ((QName[])(QName[])this.typeName)[0];
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract BeanT createInstance(UnmarshallingContext paramUnmarshallingContext)
/*     */     throws IllegalAccessException, InvocationTargetException, InstantiationException, SAXException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract boolean reset(BeanT paramBeanT, UnmarshallingContext paramUnmarshallingContext)
/*     */     throws SAXException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract String getId(BeanT paramBeanT, XMLSerializer paramXMLSerializer)
/*     */     throws SAXException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract void serializeBody(BeanT paramBeanT, XMLSerializer paramXMLSerializer)
/*     */     throws SAXException, IOException, XMLStreamException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract void serializeAttributes(BeanT paramBeanT, XMLSerializer paramXMLSerializer)
/*     */     throws SAXException, IOException, XMLStreamException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract void serializeRoot(BeanT paramBeanT, XMLSerializer paramXMLSerializer)
/*     */     throws SAXException, IOException, XMLStreamException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 403 */   private static final Class[] unmarshalEventParams = { Unmarshaller.class, Object.class };
/* 404 */   private static Class[] marshalEventParams = { Marshaller.class };
/*     */   
/*     */   public abstract void serializeURIs(BeanT paramBeanT, XMLSerializer paramXMLSerializer) throws SAXException;
/*     */   
/*     */   public abstract Loader getLoader(JAXBContextImpl paramJAXBContextImpl, boolean paramBoolean);
/*     */   
/*     */   public abstract Transducer<BeanT> getTransducer();
/*     */   
/*     */   protected void link(JAXBContextImpl grammar) {}
/*     */   
/*     */   public void wrapUp() {}
/*     */   
/* 416 */   protected final void setLifecycleFlags() { try { Method m; try { m = this.jaxbType.getDeclaredMethod("beforeUnmarshal", unmarshalEventParams);
/* 417 */         cacheLifecycleMethod(m, (short)8);
/*     */       }
/*     */       catch (NoSuchMethodException e) {}
/*     */       
/*     */ 
/*     */       try
/*     */       {
/* 424 */         m = this.jaxbType.getDeclaredMethod("afterUnmarshal", unmarshalEventParams);
/* 425 */         cacheLifecycleMethod(m, (short)16);
/*     */       }
/*     */       catch (NoSuchMethodException e) {}
/*     */       
/*     */ 
/*     */       try
/*     */       {
/* 432 */         m = this.jaxbType.getDeclaredMethod("beforeMarshal", marshalEventParams);
/* 433 */         cacheLifecycleMethod(m, (short)32);
/*     */       }
/*     */       catch (NoSuchMethodException e) {}
/*     */       
/*     */ 
/*     */       try
/*     */       {
/* 440 */         m = this.jaxbType.getDeclaredMethod("afterMarshal", marshalEventParams);
/* 441 */         cacheLifecycleMethod(m, (short)64);
/*     */       }
/*     */       catch (NoSuchMethodException e) {}
/*     */     }
/*     */     catch (SecurityException e)
/*     */     {
/* 447 */       logger.log(Level.WARNING, Messages.UNABLE_TO_DISCOVER_EVENTHANDLER.format(new Object[] { this.jaxbType.getName(), e }));
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private void cacheLifecycleMethod(Method m, short lifecycleFlag)
/*     */   {
/* 463 */     if (this.lcm == null) {
/* 464 */       this.lcm = new LifecycleMethods();
/*     */     }
/*     */     
/*     */ 
/* 468 */     m.setAccessible(true);
/*     */     
/* 470 */     this.flag = ((short)(this.flag | lifecycleFlag));
/*     */     
/* 472 */     switch (lifecycleFlag) {
/*     */     case 8: 
/* 474 */       this.lcm.setBeforeUnmarshal(m);
/* 475 */       break;
/*     */     case 16: 
/* 477 */       this.lcm.setAfterUnmarshal(m);
/* 478 */       break;
/*     */     case 32: 
/* 480 */       this.lcm.setBeforeMarshal(m);
/* 481 */       break;
/*     */     case 64: 
/* 483 */       this.lcm.setAfterMarshal(m);
/*     */     }
/*     */     
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final LifecycleMethods getLifecycleMethods()
/*     */   {
/* 494 */     return this.lcm;
/*     */   }
/*     */   
/*     */ 
/*     */   public final void invokeBeforeUnmarshalMethod(UnmarshallerImpl unm, Object child, Object parent)
/*     */     throws SAXException
/*     */   {
/* 501 */     Method m = getLifecycleMethods().getBeforeUnmarshal();
/* 502 */     invokeUnmarshallCallback(m, child, unm, parent);
/*     */   }
/*     */   
/*     */ 
/*     */   public final void invokeAfterUnmarshalMethod(UnmarshallerImpl unm, Object child, Object parent)
/*     */     throws SAXException
/*     */   {
/* 509 */     Method m = getLifecycleMethods().getAfterUnmarshal();
/* 510 */     invokeUnmarshallCallback(m, child, unm, parent);
/*     */   }
/*     */   
/*     */   private void invokeUnmarshallCallback(Method m, Object child, UnmarshallerImpl unm, Object parent) throws SAXException {
/*     */     try {
/* 515 */       m.invoke(child, new Object[] { unm, parent });
/*     */     } catch (IllegalAccessException e) {
/* 517 */       UnmarshallingContext.getInstance().handleError(e);
/*     */     } catch (InvocationTargetException e) {
/* 519 */       UnmarshallingContext.getInstance().handleError(e);
/*     */     }
/*     */   }
/*     */   
/* 523 */   private static final Logger logger = Util.getClassLogger();
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\JaxBeanInfo.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */