/*     */ package com.sun.xml.bind.v2.runtime.unmarshaller;
/*     */ 
/*     */ import com.sun.xml.bind.api.AccessorException;
/*     */ import com.sun.xml.bind.v2.runtime.ClassBeanInfoImpl;
/*     */ import com.sun.xml.bind.v2.runtime.JAXBContextImpl;
/*     */ import com.sun.xml.bind.v2.runtime.JaxBeanInfo;
/*     */ import com.sun.xml.bind.v2.runtime.Name;
/*     */ import com.sun.xml.bind.v2.runtime.property.AttributeProperty;
/*     */ import com.sun.xml.bind.v2.runtime.property.Property;
/*     */ import com.sun.xml.bind.v2.runtime.property.StructureLoaderBuilder;
/*     */ import com.sun.xml.bind.v2.runtime.property.UnmarshallerChain;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.TransducedAccessor;
/*     */ import com.sun.xml.bind.v2.util.QNameMap;
/*     */ import java.util.Collection;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ import javax.xml.namespace.QName;
/*     */ import org.xml.sax.Attributes;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class StructureLoader
/*     */   extends Loader
/*     */ {
/*  41 */   private final QNameMap<ChildLoader> childUnmarshallers = new QNameMap();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private ChildLoader catchAll;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private ChildLoader textHandler;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private QNameMap<TransducedAccessor> attUnmarshallers;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private Accessor<Object, Map<QName, String>> attCatchAll;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private final JaxBeanInfo beanInfo;
/*     */   
/*     */ 
/*     */ 
/*     */   private int frameSize;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public StructureLoader(ClassBeanInfoImpl beanInfo)
/*     */   {
/*  77 */     super(true);
/*  78 */     this.beanInfo = beanInfo;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void init(JAXBContextImpl context, ClassBeanInfoImpl beanInfo, Accessor<?, Map<QName, String>> attWildcard)
/*     */   {
/*  89 */     UnmarshallerChain chain = new UnmarshallerChain(context);
/*  90 */     for (ClassBeanInfoImpl bi = beanInfo; bi != null; bi = bi.superClazz) {
/*  91 */       for (int i = bi.properties.length - 1; i >= 0; i--) {
/*  92 */         Property p = bi.properties[i];
/*     */         
/*  94 */         switch (p.getKind()) {
/*     */         case ATTRIBUTE: 
/*  96 */           if (this.attUnmarshallers == null)
/*  97 */             this.attUnmarshallers = new QNameMap();
/*  98 */           AttributeProperty ap = (AttributeProperty)p;
/*  99 */           this.attUnmarshallers.put(ap.attName.toQName(), ap.xacc);
/* 100 */           break;
/*     */         case ELEMENT: 
/*     */         case REFERENCE: 
/*     */         case MAP: 
/*     */         case VALUE: 
/* 105 */           p.buildChildElementUnmarshallers(chain, this.childUnmarshallers);
/*     */         }
/*     */         
/*     */       }
/*     */     }
/*     */     
/* 111 */     this.frameSize = chain.getScopeSize();
/*     */     
/* 113 */     this.textHandler = ((ChildLoader)this.childUnmarshallers.get(StructureLoaderBuilder.TEXT_HANDLER));
/* 114 */     this.catchAll = ((ChildLoader)this.childUnmarshallers.get(StructureLoaderBuilder.CATCH_ALL));
/*     */     
/* 116 */     if (attWildcard != null) {
/* 117 */       this.attCatchAll = attWildcard;
/*     */       
/*     */ 
/* 120 */       if (this.attUnmarshallers == null)
/* 121 */         this.attUnmarshallers = EMPTY;
/*     */     } else {
/* 123 */       this.attCatchAll = null;
/*     */     }
/*     */   }
/*     */   
/*     */   public void startElement(UnmarshallingContext.State state, TagName ea) throws SAXException
/*     */   {
/* 129 */     UnmarshallingContext context = state.getContext();
/*     */     
/*     */ 
/*     */ 
/* 133 */     assert (!this.beanInfo.isImmutable());
/*     */     
/*     */ 
/* 136 */     Object child = context.getInnerPeer();
/*     */     
/* 138 */     if ((child != null) && (this.beanInfo.jaxbType != child.getClass())) {
/* 139 */       child = null;
/*     */     }
/* 141 */     if (child != null) {
/* 142 */       this.beanInfo.reset(child, context);
/*     */     }
/* 144 */     if (child == null) {
/* 145 */       child = context.createInstance(this.beanInfo);
/*     */     }
/* 147 */     context.recordInnerPeer(child);
/*     */     
/* 149 */     state.target = child;
/*     */     
/* 151 */     fireBeforeUnmarshal(this.beanInfo, child, state);
/*     */     
/*     */ 
/* 154 */     context.startScope(this.frameSize);
/*     */     
/* 156 */     if (this.attUnmarshallers != null) {
/* 157 */       Attributes atts = ea.atts;
/* 158 */       for (int i = 0; i < atts.getLength(); i++) {
/* 159 */         String auri = atts.getURI(i);
/* 160 */         String alocal = atts.getLocalName(i);
/* 161 */         String avalue = atts.getValue(i);
/* 162 */         TransducedAccessor xacc = (TransducedAccessor)this.attUnmarshallers.get(auri, alocal);
/*     */         try
/*     */         {
/* 165 */           if (xacc != null) {
/* 166 */             xacc.parse(child, avalue);
/*     */           }
/* 168 */           else if (this.attCatchAll != null) {
/* 169 */             String qname = atts.getQName(i);
/* 170 */             if (atts.getURI(i).equals("http://www.w3.org/2001/XMLSchema-instance"))
/*     */               continue;
/* 172 */             Object o = state.target;
/* 173 */             Map<QName, String> map = (Map)this.attCatchAll.get(o);
/* 174 */             if (map == null)
/*     */             {
/*     */ 
/*     */ 
/* 178 */               if (this.attCatchAll.valueType.isAssignableFrom(HashMap.class)) {
/* 179 */                 map = new HashMap();
/*     */               }
/*     */               else
/*     */               {
/* 183 */                 context.handleError(Messages.UNABLE_TO_CREATE_MAP.format(new Object[] { this.attCatchAll.valueType }));
/* 184 */                 return;
/*     */               }
/* 186 */               this.attCatchAll.set(o, map);
/*     */             }
/*     */             
/*     */ 
/* 190 */             int idx = qname.indexOf(':');
/* 191 */             String prefix; String prefix; if (idx < 0) prefix = ""; else {
/* 192 */               prefix = qname.substring(0, idx);
/*     */             }
/* 194 */             map.put(new QName(auri, alocal, prefix), avalue);
/*     */           }
/*     */         } catch (AccessorException e) {
/* 197 */           handleGenericException(e, true);
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public void childElement(UnmarshallingContext.State state, TagName arg) throws SAXException
/*     */   {
/* 205 */     ChildLoader child = (ChildLoader)this.childUnmarshallers.get(arg.uri, arg.local);
/* 206 */     if (child == null) {
/* 207 */       child = this.catchAll;
/* 208 */       if (child == null) {
/* 209 */         super.childElement(state, arg);
/* 210 */         return;
/*     */       }
/*     */     }
/*     */     
/* 214 */     state.loader = child.loader;
/* 215 */     state.receiver = child.receiver;
/*     */   }
/*     */   
/*     */   public Collection<QName> getExpectedChildElements()
/*     */   {
/* 220 */     return this.childUnmarshallers.keySet();
/*     */   }
/*     */   
/*     */   public void text(UnmarshallingContext.State state, CharSequence text) throws SAXException
/*     */   {
/* 225 */     if (this.textHandler != null)
/* 226 */       this.textHandler.loader.text(state, text);
/*     */   }
/*     */   
/*     */   public void leaveElement(UnmarshallingContext.State state, TagName ea) throws SAXException {
/* 230 */     state.getContext().endScope(this.frameSize);
/* 231 */     fireAfterUnmarshal(this.beanInfo, state.target, state.prev);
/*     */   }
/*     */   
/* 234 */   private static final QNameMap<TransducedAccessor> EMPTY = new QNameMap();
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\unmarshaller\StructureLoader.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */