/*     */ package net.rubyeye.xmemcached;
/*     */ 
/*     */ import java.util.concurrent.TimeoutException;
/*     */ import net.rubyeye.xmemcached.exception.MemcachedClientException;
/*     */ import net.rubyeye.xmemcached.exception.MemcachedException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class Counter
/*     */ {
/*     */   private final MemcachedClient memcachedClient;
/*     */   private final String key;
/*     */   private final long initialValue;
/*     */   
/*     */   public int hashCode()
/*     */   {
/*  21 */     int prime = 31;
/*  22 */     int result = 1;
/*  23 */     result = 31 * result + (this.key == null ? 0 : this.key.hashCode());
/*     */     
/*  25 */     result = 31 * result + (this.memcachedClient == null ? 0 : this.memcachedClient.hashCode());
/*     */     
/*     */ 
/*     */ 
/*  29 */     return result;
/*     */   }
/*     */   
/*     */   public boolean equals(Object obj)
/*     */   {
/*  34 */     if (this == obj) {
/*  35 */       return true;
/*     */     }
/*  37 */     if (obj == null) {
/*  38 */       return false;
/*     */     }
/*  40 */     if (getClass() != obj.getClass()) {
/*  41 */       return false;
/*     */     }
/*  43 */     Counter other = (Counter)obj;
/*  44 */     if (this.key == null) {
/*  45 */       if (other.key != null) {
/*  46 */         return false;
/*     */       }
/*  48 */     } else if (!this.key.equals(other.key)) {
/*  49 */       return false;
/*     */     }
/*  51 */     if (this.memcachedClient == null) {
/*  52 */       if (other.memcachedClient != null) {
/*  53 */         return false;
/*     */       }
/*  55 */     } else if (!this.memcachedClient.equals(other.memcachedClient)) {
/*  56 */       return false;
/*     */     }
/*  58 */     return true;
/*     */   }
/*     */   
/*     */   public final String getKey() {
/*  62 */     return this.key;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public long get()
/*     */     throws MemcachedException, InterruptedException, TimeoutException
/*     */   {
/*  75 */     Object result = this.memcachedClient.get(this.key);
/*  76 */     if (result == null) {
/*  77 */       throw new MemcachedClientException("key is not existed.");
/*     */     }
/*  79 */     if ((result instanceof Long)) {
/*  80 */       return ((Long)result).longValue();
/*     */     }
/*  82 */     return Long.valueOf(((String)result).trim()).longValue();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void set(long value)
/*     */     throws MemcachedException, InterruptedException, TimeoutException
/*     */   {
/*  96 */     this.memcachedClient.set(this.key, 0, String.valueOf(value));
/*     */   }
/*     */   
/*     */ 
/*     */   public Counter(MemcachedClient memcachedClient, String key, long initialValue)
/*     */   {
/* 102 */     this.memcachedClient = memcachedClient;
/* 103 */     this.key = key;
/* 104 */     this.initialValue = initialValue;
/*     */     try {
/* 106 */       this.memcachedClient.add(key, 0, String.valueOf(this.initialValue));
/*     */     } catch (InterruptedException e) {
/* 108 */       Thread.currentThread().interrupt();
/*     */     } catch (Exception e) {
/* 110 */       throw new IllegalStateException("Initialize counter failed", e);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public long incrementAndGet()
/*     */     throws MemcachedException, InterruptedException, TimeoutException
/*     */   {
/* 124 */     return this.memcachedClient.incr(this.key, 1L, this.initialValue);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public long decrementAndGet()
/*     */     throws MemcachedException, InterruptedException, TimeoutException
/*     */   {
/* 137 */     return this.memcachedClient.decr(this.key, 1L, this.initialValue);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public long addAndGet(long delta)
/*     */     throws MemcachedException, InterruptedException, TimeoutException
/*     */   {
/* 151 */     if (delta >= 0L) {
/* 152 */       return this.memcachedClient.incr(this.key, delta, this.initialValue);
/*     */     }
/*     */     
/* 155 */     return this.memcachedClient.decr(this.key, -delta, this.initialValue);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\Counter.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */