/*     */ package org.codehaus.jackson.map.jsontype.impl;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import org.codehaus.jackson.JsonParser;
/*     */ import org.codehaus.jackson.JsonProcessingException;
/*     */ import org.codehaus.jackson.JsonToken;
/*     */ import org.codehaus.jackson.annotate.JsonTypeInfo.As;
/*     */ import org.codehaus.jackson.map.BeanProperty;
/*     */ import org.codehaus.jackson.map.DeserializationContext;
/*     */ import org.codehaus.jackson.map.JsonDeserializer;
/*     */ import org.codehaus.jackson.map.jsontype.TypeIdResolver;
/*     */ import org.codehaus.jackson.type.JavaType;
/*     */ import org.codehaus.jackson.util.JsonParserSequence;
/*     */ import org.codehaus.jackson.util.TokenBuffer;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class AsPropertyTypeDeserializer
/*     */   extends AsArrayTypeDeserializer
/*     */ {
/*     */   protected final String _typePropertyName;
/*     */   
/*     */   public AsPropertyTypeDeserializer(JavaType bt, TypeIdResolver idRes, BeanProperty property, String typePropName)
/*     */   {
/*  31 */     super(bt, idRes, property);
/*  32 */     this._typePropertyName = typePropName;
/*     */   }
/*     */   
/*     */   public JsonTypeInfo.As getTypeInclusion()
/*     */   {
/*  37 */     return JsonTypeInfo.As.PROPERTY;
/*     */   }
/*     */   
/*     */   public String getPropertyName() {
/*  41 */     return this._typePropertyName;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Object deserializeTypedFromObject(JsonParser jp, DeserializationContext ctxt)
/*     */     throws IOException, JsonProcessingException
/*     */   {
/*  52 */     JsonToken t = jp.getCurrentToken();
/*  53 */     if (t == JsonToken.START_OBJECT) {
/*  54 */       t = jp.nextToken();
/*  55 */     } else if (t != JsonToken.FIELD_NAME) {
/*  56 */       throw ctxt.wrongTokenException(jp, JsonToken.START_OBJECT, "need JSON Object to contain As.PROPERTY type information (for class " + baseTypeName() + ")");
/*     */     }
/*     */     
/*     */ 
/*  60 */     TokenBuffer tb = null;
/*  62 */     for (; 
/*  62 */         t == JsonToken.FIELD_NAME; t = jp.nextToken()) {
/*  63 */       String name = jp.getCurrentName();
/*  64 */       jp.nextToken();
/*  65 */       if (this._typePropertyName.equals(name)) {
/*  66 */         String typeId = jp.getText();
/*  67 */         JsonDeserializer<Object> deser = _findDeserializer(ctxt, typeId);
/*     */         
/*  69 */         if (tb != null) {
/*  70 */           jp = JsonParserSequence.createFlattened(tb.asParser(jp), jp);
/*     */         }
/*     */         
/*     */ 
/*     */ 
/*  75 */         jp.nextToken();
/*     */         
/*  77 */         return deser.deserialize(jp, ctxt);
/*     */       }
/*  79 */       if (tb == null) {
/*  80 */         tb = new TokenBuffer(null);
/*     */       }
/*  82 */       tb.writeFieldName(name);
/*  83 */       tb.copyCurrentStructure(jp);
/*     */     }
/*     */     
/*  86 */     throw ctxt.wrongTokenException(jp, JsonToken.FIELD_NAME, "missing property '" + this._typePropertyName + "' that is to contain type id  (for class " + baseTypeName() + ")");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Object deserializeTypedFromAny(JsonParser jp, DeserializationContext ctxt)
/*     */     throws IOException, JsonProcessingException
/*     */   {
/* 101 */     if (jp.getCurrentToken() == JsonToken.START_ARRAY) {
/* 102 */       return super.deserializeTypedFromArray(jp, ctxt);
/*     */     }
/* 104 */     return deserializeTypedFromObject(jp, ctxt);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\jsontype\impl\AsPropertyTypeDeserializer.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */