/*     */ package org.codehaus.jackson.map.module;
/*     */ 
/*     */ import org.codehaus.jackson.Version;
/*     */ import org.codehaus.jackson.map.JsonDeserializer;
/*     */ import org.codehaus.jackson.map.JsonSerializer;
/*     */ import org.codehaus.jackson.map.KeyDeserializer;
/*     */ import org.codehaus.jackson.map.Module;
/*     */ import org.codehaus.jackson.map.Module.SetupContext;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SimpleModule
/*     */   extends Module
/*     */ {
/*     */   protected final String _name;
/*     */   protected final Version _version;
/*  18 */   protected SimpleSerializers _serializers = null;
/*  19 */   protected SimpleDeserializers _deserializers = null;
/*     */   
/*  21 */   protected SimpleSerializers _keySerializers = null;
/*  22 */   protected SimpleKeyDeserializers _keyDeserializers = null;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  29 */   protected SimpleAbstractTypeResolver _abstractTypes = null;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public SimpleModule(String name, Version version)
/*     */   {
/*  39 */     this._name = name;
/*  40 */     this._version = version;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public SimpleModule addSerializer(JsonSerializer<?> ser)
/*     */   {
/*  51 */     if (this._serializers == null) {
/*  52 */       this._serializers = new SimpleSerializers();
/*     */     }
/*  54 */     this._serializers.addSerializer(ser);
/*  55 */     return this;
/*     */   }
/*     */   
/*     */   public <T> SimpleModule addSerializer(Class<? extends T> type, JsonSerializer<T> ser)
/*     */   {
/*  60 */     if (this._serializers == null) {
/*  61 */       this._serializers = new SimpleSerializers();
/*     */     }
/*  63 */     this._serializers.addSerializer(type, ser);
/*  64 */     return this;
/*     */   }
/*     */   
/*     */   public <T> SimpleModule addKeySerializer(Class<? extends T> type, JsonSerializer<T> ser)
/*     */   {
/*  69 */     if (this._keySerializers == null) {
/*  70 */       this._keySerializers = new SimpleSerializers();
/*     */     }
/*  72 */     this._keySerializers.addSerializer(type, ser);
/*  73 */     return this;
/*     */   }
/*     */   
/*     */   public <T> SimpleModule addDeserializer(Class<T> type, JsonDeserializer<? extends T> deser)
/*     */   {
/*  78 */     if (this._deserializers == null) {
/*  79 */       this._deserializers = new SimpleDeserializers();
/*     */     }
/*  81 */     this._deserializers.addDeserializer(type, deser);
/*  82 */     return this;
/*     */   }
/*     */   
/*     */   public SimpleModule addKeyDeserializer(Class<?> type, KeyDeserializer deser)
/*     */   {
/*  87 */     if (this._keyDeserializers == null) {
/*  88 */       this._keyDeserializers = new SimpleKeyDeserializers();
/*     */     }
/*  90 */     this._keyDeserializers.addDeserializer(type, deser);
/*  91 */     return this;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public <T> SimpleModule addAbstractTypeMapping(Class<T> superType, Class<? extends T> subType)
/*     */   {
/* 102 */     if (this._abstractTypes == null) {
/* 103 */       this._abstractTypes = new SimpleAbstractTypeResolver();
/*     */     }
/*     */     
/* 106 */     this._abstractTypes = this._abstractTypes.addMapping(superType, subType);
/* 107 */     return this;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getModuleName()
/*     */   {
/* 118 */     return this._name;
/*     */   }
/*     */   
/*     */ 
/*     */   public void setupModule(Module.SetupContext context)
/*     */   {
/* 124 */     if (this._serializers != null) {
/* 125 */       context.addSerializers(this._serializers);
/*     */     }
/* 127 */     if (this._deserializers != null) {
/* 128 */       context.addDeserializers(this._deserializers);
/*     */     }
/* 130 */     if (this._keySerializers != null) {
/* 131 */       context.addKeySerializers(this._keySerializers);
/*     */     }
/* 133 */     if (this._keyDeserializers != null) {
/* 134 */       context.addKeyDeserializers(this._keyDeserializers);
/*     */     }
/* 136 */     if (this._abstractTypes != null) {
/* 137 */       context.addAbstractTypeResolver(this._abstractTypes);
/*     */     }
/*     */   }
/*     */   
/*     */   public Version version()
/*     */   {
/* 143 */     return this._version;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\module\SimpleModule.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */