/*     */ package org.codehaus.jackson.map.type;
/*     */ 
/*     */ import java.lang.reflect.Array;
/*     */ import org.codehaus.jackson.type.JavaType;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class ArrayType
/*     */   extends TypeBase
/*     */ {
/*     */   final JavaType _componentType;
/*     */   final Object _emptyArray;
/*     */   
/*     */   private ArrayType(JavaType componentType, Object emptyInstance)
/*     */   {
/*  29 */     super(emptyInstance.getClass(), componentType.hashCode());
/*  30 */     this._componentType = componentType;
/*  31 */     this._emptyArray = emptyInstance;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static ArrayType construct(JavaType componentType)
/*     */   {
/*  42 */     Object emptyInstance = Array.newInstance(componentType.getRawClass(), 0);
/*  43 */     return new ArrayType(componentType, emptyInstance);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public ArrayType withTypeHandler(Object h)
/*     */   {
/*  50 */     ArrayType newInstance = new ArrayType(this._componentType, this._emptyArray);
/*  51 */     newInstance._typeHandler = h;
/*  52 */     return newInstance;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public ArrayType withContentTypeHandler(Object h)
/*     */   {
/*  59 */     return new ArrayType(this._componentType.withTypeHandler(h), this._emptyArray);
/*     */   }
/*     */   
/*     */   protected String buildCanonicalName()
/*     */   {
/*  64 */     return this._class.getName();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected JavaType _narrow(Class<?> subclass)
/*     */   {
/*  83 */     if (!subclass.isArray()) {
/*  84 */       throw new IllegalArgumentException("Incompatible narrowing operation: trying to narrow " + toString() + " to class " + subclass.getName());
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*  89 */     Class<?> newCompClass = subclass.getComponentType();
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  97 */     JavaType newCompType = TypeFactory.defaultInstance().constructType(newCompClass);
/*  98 */     return construct(newCompType);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public JavaType narrowContentsBy(Class<?> contentClass)
/*     */   {
/* 109 */     if (contentClass == this._componentType.getRawClass()) {
/* 110 */       return this;
/*     */     }
/* 112 */     return construct(this._componentType.narrowBy(contentClass)).copyHandlers(this);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public JavaType widenContentsBy(Class<?> contentClass)
/*     */   {
/* 119 */     if (contentClass == this._componentType.getRawClass()) {
/* 120 */       return this;
/*     */     }
/* 122 */     return construct(this._componentType.widenBy(contentClass)).copyHandlers(this);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isArrayType()
/*     */   {
/* 132 */     return true;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isAbstract()
/*     */   {
/* 140 */     return false;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isConcrete()
/*     */   {
/* 148 */     return true;
/*     */   }
/*     */   
/*     */   public boolean hasGenericTypes()
/*     */   {
/* 153 */     return this._componentType.hasGenericTypes();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String containedTypeName(int index)
/*     */   {
/* 164 */     if (index == 0) return "E";
/* 165 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isContainerType()
/*     */   {
/* 175 */     return true;
/*     */   }
/*     */   
/* 178 */   public JavaType getContentType() { return this._componentType; }
/*     */   
/*     */   public int containedTypeCount() {
/* 181 */     return 1;
/*     */   }
/*     */   
/* 184 */   public JavaType containedType(int index) { return index == 0 ? this._componentType : null; }
/*     */   
/*     */ 
/*     */   public StringBuilder getGenericSignature(StringBuilder sb)
/*     */   {
/* 189 */     sb.append('[');
/* 190 */     return this._componentType.getGenericSignature(sb);
/*     */   }
/*     */   
/*     */   public StringBuilder getErasedSignature(StringBuilder sb)
/*     */   {
/* 195 */     sb.append('[');
/* 196 */     return this._componentType.getErasedSignature(sb);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String toString()
/*     */   {
/* 208 */     return "[array type, component type: " + this._componentType + "]";
/*     */   }
/*     */   
/*     */ 
/*     */   public boolean equals(Object o)
/*     */   {
/* 214 */     if (o == this) return true;
/* 215 */     if (o == null) return false;
/* 216 */     if (o.getClass() != getClass()) { return false;
/*     */     }
/* 218 */     ArrayType other = (ArrayType)o;
/* 219 */     return this._componentType.equals(other._componentType);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\type\ArrayType.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */