/*     */ package org.codehaus.janino;
/*     */ 
/*     */ import java.util.ArrayList;
/*     */ import java.util.HashMap;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import org.codehaus.commons.compiler.CompileException;
/*     */ import org.codehaus.janino.util.ClassFile;
/*     */ import org.codehaus.janino.util.ClassFile.AttributeInfo;
/*     */ import org.codehaus.janino.util.ClassFile.ConstantClassInfo;
/*     */ import org.codehaus.janino.util.ClassFile.ConstantNameAndTypeInfo;
/*     */ import org.codehaus.janino.util.ClassFile.ConstantPoolInfo;
/*     */ import org.codehaus.janino.util.ClassFile.ConstantValueAttribute;
/*     */ import org.codehaus.janino.util.ClassFile.ConstantValuePoolInfo;
/*     */ import org.codehaus.janino.util.ClassFile.ExceptionsAttribute;
/*     */ import org.codehaus.janino.util.ClassFile.FieldInfo;
/*     */ import org.codehaus.janino.util.ClassFile.InnerClassesAttribute;
/*     */ import org.codehaus.janino.util.ClassFile.InnerClassesAttribute.Entry;
/*     */ import org.codehaus.janino.util.ClassFile.MethodInfo;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ClassFileIClass
/*     */   extends IClass
/*     */ {
/*     */   private static final boolean DEBUG = false;
/*     */   private final ClassFile classFile;
/*     */   private final IClassLoader iClassLoader;
/*     */   private final short accessFlags;
/*  46 */   private final Map resolvedFields = new HashMap();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ClassFileIClass(ClassFile classFile, IClassLoader iClassLoader)
/*     */   {
/*  56 */     this.classFile = classFile;
/*  57 */     this.iClassLoader = iClassLoader;
/*     */     
/*     */ 
/*  60 */     this.accessFlags = classFile.accessFlags;
/*     */   }
/*     */   
/*     */ 
/*     */   protected IClass.IConstructor[] getDeclaredIConstructors2()
/*     */   {
/*  66 */     List iConstructors = new ArrayList();
/*     */     
/*  68 */     for (Iterator it = this.classFile.methodInfos.iterator(); it.hasNext();) {
/*  69 */       ClassFile.MethodInfo mi = (ClassFile.MethodInfo)it.next();
/*     */       IClass.IInvocable ii;
/*     */       try {
/*  72 */         ii = resolveMethod(mi);
/*     */       } catch (ClassNotFoundException ex) {
/*  74 */         throw new JaninoRuntimeException(ex.getMessage());
/*     */       }
/*  76 */       if ((ii instanceof IClass.IConstructor)) { iConstructors.add(ii);
/*     */       }
/*     */     }
/*  79 */     return (IClass.IConstructor[])iConstructors.toArray(new IClass.IConstructor[iConstructors.size()]);
/*     */   }
/*     */   
/*     */   protected IClass.IMethod[] getDeclaredIMethods2() {
/*  83 */     List iMethods = new ArrayList();
/*     */     
/*  85 */     for (Iterator it = this.classFile.methodInfos.iterator(); it.hasNext();) {
/*  86 */       ClassFile.MethodInfo mi = (ClassFile.MethodInfo)it.next();
/*     */       
/*     */ 
/*     */ 
/*  90 */       if ((mi.getAccessFlags() & 0x1000) == 0)
/*     */       {
/*     */         IClass.IInvocable ii;
/*     */         try {
/*  94 */           ii = resolveMethod(mi);
/*     */         } catch (ClassNotFoundException ex) {
/*  96 */           throw new JaninoRuntimeException(ex.getMessage());
/*     */         }
/*  98 */         if ((ii instanceof IClass.IMethod)) iMethods.add(ii);
/*     */       }
/*     */     }
/* 101 */     return (IClass.IMethod[])iMethods.toArray(new IClass.IMethod[iMethods.size()]);
/*     */   }
/*     */   
/*     */   protected IClass.IField[] getDeclaredIFields2() {
/* 105 */     IClass.IField[] ifs = new IClass.IField[this.classFile.fieldInfos.size()];
/* 106 */     for (int i = 0; i < this.classFile.fieldInfos.size(); i++) {
/*     */       try {
/* 108 */         ifs[i] = resolveField((ClassFile.FieldInfo)this.classFile.fieldInfos.get(i));
/*     */       } catch (ClassNotFoundException ex) {
/* 110 */         throw new JaninoRuntimeException(ex.getMessage());
/*     */       }
/*     */     }
/* 113 */     return ifs;
/*     */   }
/*     */   
/*     */   protected IClass[] getDeclaredIClasses2() throws CompileException {
/* 117 */     ClassFile.InnerClassesAttribute ica = this.classFile.getInnerClassesAttribute();
/* 118 */     if (ica == null) { return new IClass[0];
/*     */     }
/* 120 */     List ices = ica.getEntries();
/* 121 */     List res = new ArrayList();
/* 122 */     for (Iterator it = ices.iterator(); it.hasNext();) {
/* 123 */       ClassFile.InnerClassesAttribute.Entry e = (ClassFile.InnerClassesAttribute.Entry)it.next();
/* 124 */       if (e.outerClassInfoIndex == this.classFile.thisClass) {
/*     */         try {
/* 126 */           res.add(resolveClass(e.innerClassInfoIndex));
/*     */         } catch (ClassNotFoundException ex) {
/* 128 */           throw new CompileException(ex.getMessage(), null);
/*     */         }
/*     */       }
/*     */     }
/* 132 */     return (IClass[])res.toArray(new IClass[res.size()]);
/*     */   }
/*     */   
/*     */   protected IClass getDeclaringIClass2() throws CompileException {
/* 136 */     ClassFile.InnerClassesAttribute ica = this.classFile.getInnerClassesAttribute();
/* 137 */     if (ica == null) { return null;
/*     */     }
/* 139 */     List ices = ica.getEntries();
/* 140 */     for (Iterator it = ices.iterator(); it.hasNext();) {
/* 141 */       ClassFile.InnerClassesAttribute.Entry e = (ClassFile.InnerClassesAttribute.Entry)it.next();
/* 142 */       if (e.innerClassInfoIndex == this.classFile.thisClass)
/*     */       {
/* 144 */         if (e.outerClassInfoIndex == 0) return null;
/*     */         try {
/* 146 */           return resolveClass(e.outerClassInfoIndex);
/*     */         } catch (ClassNotFoundException ex) {
/* 148 */           throw new CompileException(ex.getMessage(), null);
/*     */         }
/*     */       }
/*     */     }
/* 152 */     return null;
/*     */   }
/*     */   
/*     */   protected IClass getOuterIClass2() throws CompileException {
/* 156 */     ClassFile.InnerClassesAttribute ica = this.classFile.getInnerClassesAttribute();
/* 157 */     if (ica == null) { return null;
/*     */     }
/* 159 */     List ices = ica.getEntries();
/* 160 */     for (Iterator it = ices.iterator(); it.hasNext();) {
/* 161 */       ClassFile.InnerClassesAttribute.Entry e = (ClassFile.InnerClassesAttribute.Entry)it.next();
/* 162 */       if (e.innerClassInfoIndex == this.classFile.thisClass) {
/* 163 */         if (e.outerClassInfoIndex == 0)
/*     */         {
/*     */ 
/*     */ 
/* 167 */           return null;
/*     */         }
/*     */         
/*     */ 
/* 171 */         if ((e.innerClassAccessFlags & 0x8) != 0) return null;
/*     */         try {
/* 173 */           return resolveClass(e.outerClassInfoIndex);
/*     */         } catch (ClassNotFoundException ex) {
/* 175 */           throw new CompileException(ex.getMessage(), null);
/*     */         }
/*     */       }
/*     */     }
/*     */     
/* 180 */     return null;
/*     */   }
/*     */   
/*     */   protected IClass getSuperclass2() throws CompileException {
/* 184 */     if (this.classFile.superclass == 0) return null;
/*     */     try {
/* 186 */       return resolveClass(this.classFile.superclass);
/*     */     } catch (ClassNotFoundException e) {
/* 188 */       throw new CompileException(e.getMessage(), null);
/*     */     }
/*     */   }
/*     */   
/*     */   public Access getAccess() {
/* 193 */     return accessFlags2Access(this.accessFlags);
/*     */   }
/*     */   
/*     */   public boolean isFinal() {
/* 197 */     return (this.accessFlags & 0x10) != 0;
/*     */   }
/*     */   
/*     */   protected IClass[] getInterfaces2() throws CompileException {
/* 201 */     return resolveClasses(this.classFile.interfaces);
/*     */   }
/*     */   
/*     */   public boolean isAbstract() {
/* 205 */     return (this.accessFlags & 0x400) != 0;
/*     */   }
/*     */   
/*     */   protected String getDescriptor2() {
/* 209 */     return Descriptor.fromClassName(this.classFile.getThisClassName());
/*     */   }
/*     */   
/*     */   public boolean isInterface() {
/* 213 */     return (this.accessFlags & 0x200) != 0;
/*     */   }
/*     */   
/*     */   public boolean isArray() {
/* 217 */     return false;
/*     */   }
/*     */   
/*     */   public boolean isPrimitive() {
/* 221 */     return false;
/*     */   }
/*     */   
/*     */   public boolean isPrimitiveNumeric() {
/* 225 */     return false;
/*     */   }
/*     */   
/*     */   protected IClass getComponentType2() {
/* 229 */     return null;
/*     */   }
/*     */   
/*     */   public void resolveHalf()
/*     */     throws ClassNotFoundException
/*     */   {
/* 235 */     resolveClass(this.classFile.superclass);
/*     */     
/*     */ 
/* 238 */     for (int i = 0; i < this.classFile.interfaces.length; i++) {
/* 239 */       resolveClass(this.classFile.interfaces[i]);
/*     */     }
/*     */     
/*     */ 
/* 243 */     for (int i = 0; i < this.classFile.methodInfos.size(); i++) {
/* 244 */       resolveMethod((ClassFile.MethodInfo)this.classFile.methodInfos.get(i));
/*     */     }
/*     */     
/*     */ 
/* 248 */     for (int i = 0; i < this.classFile.fieldInfos.size(); i++) {
/* 249 */       resolveField((ClassFile.FieldInfo)this.classFile.fieldInfos.get(i));
/*     */     }
/*     */   }
/*     */   
/*     */   public void resolveAllClasses() throws ClassNotFoundException {
/* 254 */     for (short i = 0; i < this.classFile.constantPool.size(); i = (short)(i + 1)) {
/* 255 */       ClassFile.ConstantPoolInfo cpi = this.classFile.getConstantPoolInfo(i);
/* 256 */       if ((cpi instanceof ClassFile.ConstantClassInfo)) {
/* 257 */         resolveClass(i);
/*     */       }
/* 259 */       else if ((cpi instanceof ClassFile.ConstantNameAndTypeInfo)) {
/* 260 */         short descriptorIndex = ((ClassFile.ConstantNameAndTypeInfo)cpi).getDescriptorIndex();
/* 261 */         String descriptor = this.classFile.getConstantUtf8(descriptorIndex);
/* 262 */         if (descriptor.charAt(0) == '(') {
/* 263 */           MethodDescriptor md = new MethodDescriptor(descriptor);
/* 264 */           resolveClass(md.returnFD);
/* 265 */           for (int j = 0; j < md.parameterFDs.length; j++) resolveClass(md.parameterFDs[j]);
/*     */         } else {
/* 267 */           resolveClass(descriptor);
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   private IClass resolveClass(short index)
/*     */     throws ClassNotFoundException
/*     */   {
/* 278 */     return resolveClass(Descriptor.fromInternalForm(this.classFile.getConstantClassName(index)));
/*     */   }
/*     */   
/*     */   private IClass resolveClass(String descriptor)
/*     */     throws ClassNotFoundException
/*     */   {
/* 284 */     IClass result = (IClass)this.resolvedClasses.get(descriptor);
/* 285 */     if (result != null) { return result;
/*     */     }
/* 287 */     result = this.iClassLoader.loadIClass(descriptor);
/* 288 */     if (result == null) { throw new ClassNotFoundException(descriptor);
/*     */     }
/* 290 */     this.resolvedClasses.put(descriptor, result);
/* 291 */     return result; }
/*     */   
/* 293 */   private final Map resolvedClasses = new HashMap();
/*     */   
/*     */   private IClass[] resolveClasses(short[] ifs) throws CompileException {
/* 296 */     IClass[] result = new IClass[ifs.length];
/* 297 */     for (int i = 0; i < result.length; i++) {
/*     */       try {
/* 299 */         result[i] = resolveClass(ifs[i]);
/*     */       } catch (ClassNotFoundException e) {
/* 301 */         throw new CompileException(e.getMessage(), null);
/*     */       }
/*     */     }
/* 304 */     return result;
/*     */   }
/*     */   
/*     */   private final IClass[] val$parameterTypes;
/*     */   
/*     */   private final IClass[] val$thrownExceptions;
/*     */   private final Access val$access;
/*     */   
/*     */   private IClass.IInvocable resolveMethod(ClassFile.MethodInfo methodInfo)
/*     */     throws ClassNotFoundException
/*     */   {
/* 315 */     IClass.IInvocable result = (IClass.IInvocable)this.resolvedMethods.get(methodInfo);
/* 316 */     if (result != null) { return result;
/*     */     }
/*     */     
/* 319 */     String name = this.classFile.getConstantUtf8(methodInfo.getNameIndex());
/*     */     
/*     */ 
/* 322 */     MethodDescriptor md = new MethodDescriptor(this.classFile.getConstantUtf8(methodInfo.getDescriptorIndex()));
/* 323 */     IClass returnType = resolveClass(md.returnFD);
/*     */     
/*     */ 
/* 326 */     IClass[] parameterTypes = new IClass[md.parameterFDs.length];
/* 327 */     for (int i = 0; i < parameterTypes.length; i++) { parameterTypes[i] = resolveClass(md.parameterFDs[i]);
/*     */     }
/*     */     
/* 330 */     IClass[] tes = null;
/* 331 */     ClassFile.AttributeInfo[] ais = methodInfo.getAttributes();
/* 332 */     for (int i = 0; i < ais.length; i++) {
/* 333 */       ClassFile.AttributeInfo ai = ais[i];
/* 334 */       if ((ai instanceof ClassFile.ExceptionsAttribute)) {
/* 335 */         short[] teis = ((ClassFile.ExceptionsAttribute)ai).getExceptionIndexes();
/* 336 */         tes = new IClass[teis.length];
/* 337 */         for (int j = 0; j < teis.length; j++) tes[j] = resolveClass(teis[j]);
/*     */       }
/*     */     }
/* 340 */     IClass[] thrownExceptions = tes == null ? new IClass[0] : tes;
/*     */     
/*     */ 
/* 343 */     Access access = accessFlags2Access(methodInfo.getAccessFlags());
/*     */     
/* 345 */     if (name.equals("<init>")) {
/* 346 */       result = new IClass.IConstructor(parameterTypes) { private final IClass[] val$parameterTypes;
/*     */         private final IClass[] val$thrownExceptions;
/*     */         private final Access val$access;
/*     */         
/* 350 */         public IClass[] getParameterTypes() throws CompileException { IClass outerIClass = ClassFileIClass.this.getOuterIClass();
/* 351 */           if (outerIClass != null) {
/* 352 */             if (this.val$parameterTypes.length < 1) {
/* 353 */               throw new JaninoRuntimeException("Inner class constructor lacks magic first parameter");
/*     */             }
/* 355 */             if (this.val$parameterTypes[0] != outerIClass) {
/* 356 */               throw new JaninoRuntimeException("Magic first parameter of inner class constructor has type \"" + this.val$parameterTypes[0].toString() + "\" instead of that of its enclosing instance (\"" + outerIClass.toString() + "\")");
/*     */             }
/*     */             
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 364 */             IClass[] tmp = new IClass[this.val$parameterTypes.length - 1];
/* 365 */             System.arraycopy(this.val$parameterTypes, 1, tmp, 0, tmp.length);
/* 366 */             return tmp;
/*     */           }
/*     */           
/* 369 */           return this.val$parameterTypes; }
/*     */         
/* 371 */         public IClass[] getThrownExceptions() throws CompileException { return this.val$thrownExceptions; }
/* 372 */         public Access getAccess() { return this.val$access; }
/*     */       };
/*     */     } else {
/* 375 */       result = new IClass.IMethod(name) { private final String val$name; private final IClass val$returnType;
/* 376 */         public String getName() { return this.val$name; } private final ClassFile.MethodInfo val$methodInfo;
/* 377 */         public IClass getReturnType() throws CompileException { return this.val$returnType; }
/* 378 */         public boolean isStatic() { return (this.val$methodInfo.getAccessFlags() & 0x8) != 0; }
/* 379 */         public boolean isAbstract() { return (this.val$methodInfo.getAccessFlags() & 0x400) != 0; }
/* 380 */         public IClass[] getParameterTypes() throws CompileException { return this.val$parameterTypes; }
/* 381 */         public IClass[] getThrownExceptions() throws CompileException { return this.val$thrownExceptions; }
/* 382 */         public Access getAccess() { return this.val$access; }
/*     */       };
/*     */     }
/* 385 */     this.resolvedMethods.put(methodInfo, result);
/* 386 */     return result; }
/*     */   
/* 388 */   private final Map resolvedMethods = new HashMap();
/*     */   private final Object val$optionalConstantValue;
/*     */   
/* 391 */   private IClass.IField resolveField(ClassFile.FieldInfo fieldInfo) throws ClassNotFoundException { IClass.IField result = (IClass.IField)this.resolvedFields.get(fieldInfo);
/* 392 */     if (result != null) { return result;
/*     */     }
/*     */     
/* 395 */     String name = this.classFile.getConstantUtf8(fieldInfo.getNameIndex());
/*     */     
/*     */ 
/* 398 */     String descriptor = this.classFile.getConstantUtf8(fieldInfo.getDescriptorIndex());
/* 399 */     IClass type = resolveClass(descriptor);
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 408 */     ClassFile.ConstantValueAttribute cva = null;
/* 409 */     ClassFile.AttributeInfo[] ais = fieldInfo.getAttributes();
/* 410 */     for (int i = 0; i < ais.length; i++) {
/* 411 */       ClassFile.AttributeInfo ai = ais[i];
/* 412 */       if ((ai instanceof ClassFile.ConstantValueAttribute)) {
/* 413 */         cva = (ClassFile.ConstantValueAttribute)ai;
/* 414 */         break;
/*     */       }
/*     */     }
/*     */     
/* 418 */     Object ocv = null;
/* 419 */     if (cva != null) {
/* 420 */       ClassFile.ConstantPoolInfo cpi = this.classFile.getConstantPoolInfo(cva.getConstantValueIndex());
/* 421 */       if ((cpi instanceof ClassFile.ConstantValuePoolInfo)) {
/* 422 */         ocv = ((ClassFile.ConstantValuePoolInfo)cpi).getValue(this.classFile);
/*     */       }
/*     */       else {
/* 425 */         throw new JaninoRuntimeException("Unexpected constant pool info type \"" + cpi.getClass().getName() + "\"");
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 430 */     Object optionalConstantValue = ocv;
/*     */     
/*     */ 
/* 433 */     Access access = accessFlags2Access(fieldInfo.getAccessFlags());
/*     */     
/* 435 */     result = new IClass.IField(optionalConstantValue) {
/* 436 */       public Object getConstantValue() throws CompileException { return this.val$optionalConstantValue; }
/* 437 */       public String getName() { return this.val$name; }
/* 438 */       public IClass getType() throws CompileException { return this.val$type; }
/* 439 */       public boolean isStatic() { return (this.val$fieldInfo.getAccessFlags() & 0x8) != 0; }
/* 440 */       public Access getAccess() { return this.val$access; }
/* 441 */     };
/* 442 */     this.resolvedFields.put(fieldInfo, result);
/* 443 */     return result; }
/*     */   
/*     */   private final String val$name;
/*     */   
/* 447 */   private static Access accessFlags2Access(short accessFlags) { return (accessFlags & 0x2) != 0 ? Access.PRIVATE : (accessFlags & 0x4) != 0 ? Access.PROTECTED : (accessFlags & 0x1) != 0 ? Access.PUBLIC : Access.DEFAULT; }
/*     */   
/*     */   private final IClass val$type;
/*     */   private final ClassFile.FieldInfo val$fieldInfo;
/*     */   private final Access val$access;
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\ClassFileIClass.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */