/*    */ package com.sun.xml.bind.v2.runtime.unmarshaller;
/*    */ 
/*    */ import com.sun.xml.bind.DatatypeConverterImpl;
/*    */ import com.sun.xml.bind.v2.runtime.JAXBContextImpl;
/*    */ import com.sun.xml.bind.v2.runtime.JaxBeanInfo;
/*    */ import javax.xml.namespace.QName;
/*    */ import org.xml.sax.Attributes;
/*    */ import org.xml.sax.SAXException;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class XsiTypeLoader
/*    */   extends Loader
/*    */ {
/*    */   private final JaxBeanInfo defaultBeanInfo;
/*    */   
/*    */   public XsiTypeLoader(JaxBeanInfo defaultBeanInfo)
/*    */   {
/* 25 */     super(true);
/* 26 */     this.defaultBeanInfo = defaultBeanInfo;
/*    */   }
/*    */   
/*    */   public void startElement(UnmarshallingContext.State state, TagName ea) throws SAXException {
/* 30 */     JaxBeanInfo beanInfo = parseXsiType(state, ea);
/* 31 */     if (beanInfo == null) {
/* 32 */       beanInfo = this.defaultBeanInfo;
/*    */     }
/* 34 */     Loader loader = beanInfo.getLoader(null, false);
/* 35 */     state.loader = loader;
/* 36 */     loader.startElement(state, ea);
/*    */   }
/*    */   
/*    */   static JaxBeanInfo parseXsiType(UnmarshallingContext.State state, TagName ea) throws SAXException {
/* 40 */     UnmarshallingContext context = state.getContext();
/* 41 */     JaxBeanInfo beanInfo = null;
/*    */     
/*    */ 
/* 44 */     Attributes atts = ea.atts;
/* 45 */     int idx = atts.getIndex("http://www.w3.org/2001/XMLSchema-instance", "type");
/*    */     
/* 47 */     if (idx >= 0)
/*    */     {
/*    */ 
/* 50 */       String value = atts.getValue(idx);
/*    */       
/* 52 */       QName type = DatatypeConverterImpl._parseQName(value, context);
/* 53 */       if (type == null) {
/* 54 */         reportError(Messages.NOT_A_QNAME.format(new Object[] { value }), true);
/*    */       } else {
/* 56 */         beanInfo = context.getJAXBContext().getGlobalType(type);
/* 57 */         if (beanInfo == null) {
/* 58 */           String nearest = context.getJAXBContext().getNearestTypeName(type);
/* 59 */           if (nearest != null) {
/* 60 */             reportError(Messages.UNRECOGNIZED_TYPE_NAME_MAYBE.format(new Object[] { type, nearest }), true);
/*    */           } else {
/* 62 */             reportError(Messages.UNRECOGNIZED_TYPE_NAME.format(new Object[] { type }), true);
/*    */           }
/*    */         }
/*    */       }
/*    */     }
/*    */     
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/* 74 */     return beanInfo;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\unmarshaller\XsiTypeLoader.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */