/*     */ package net.rubyeye.xmemcached.command.text;
/*     */ 
/*     */ import com.google.code.yanf4j.buffer.IoBuffer;
/*     */ import java.nio.ByteBuffer;
/*     */ import java.util.concurrent.CountDownLatch;
/*     */ import net.rubyeye.xmemcached.command.Command;
/*     */ import net.rubyeye.xmemcached.command.CommandType;
/*     */ import net.rubyeye.xmemcached.impl.MemcachedTCPSession;
/*     */ import net.rubyeye.xmemcached.monitor.Constants;
/*     */ import net.rubyeye.xmemcached.utils.ByteUtils;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class TextIncrDecrCommand
/*     */   extends Command
/*     */ {
/*     */   private long delta;
/*     */   private final long initial;
/*     */   
/*     */   public TextIncrDecrCommand(String key, byte[] keyBytes, CommandType cmdType, CountDownLatch latch, long delta, long initial, boolean noreply)
/*     */   {
/*  50 */     super(key, keyBytes, cmdType, latch);
/*  51 */     this.delta = delta;
/*  52 */     this.noreply = noreply;
/*  53 */     this.initial = initial;
/*     */   }
/*     */   
/*     */   public final long getDelta() {
/*  57 */     return this.delta;
/*     */   }
/*     */   
/*     */   public final void setDelta(int delta) {
/*  61 */     this.delta = delta;
/*     */   }
/*     */   
/*     */   public final boolean decode(MemcachedTCPSession session, ByteBuffer buffer)
/*     */   {
/*  66 */     String line = ByteUtils.nextLine(buffer);
/*  67 */     if (line != null) {
/*  68 */       if (line.equals("NOT_FOUND"))
/*     */       {
/*     */ 
/*  71 */         setResult("NOT_FOUND");
/*  72 */         countDownLatch();
/*  73 */         return true;
/*     */       }
/*  75 */       String rt = line.trim();
/*  76 */       if (Character.isDigit(rt.charAt(0))) {
/*  77 */         setResult(Long.valueOf(rt));
/*  78 */         countDownLatch();
/*  79 */         return true;
/*     */       }
/*  81 */       return decodeError(line);
/*     */     }
/*     */     
/*     */ 
/*  85 */     return false;
/*     */   }
/*     */   
/*     */   public final void encode()
/*     */   {
/*  90 */     byte[] cmdBytes = this.commandType == CommandType.INCR ? Constants.INCR : Constants.DECR;
/*     */     
/*  92 */     int size = 6 + this.keyBytes.length + ByteUtils.stringSize(getDelta()) + Constants.CRLF.length;
/*     */     
/*  94 */     if (isNoreply()) {
/*  95 */       size += 8;
/*     */     }
/*  97 */     byte[] buf = new byte[size];
/*  98 */     if (isNoreply()) {
/*  99 */       ByteUtils.setArguments(buf, 0, new Object[] { cmdBytes, this.keyBytes, Long.valueOf(getDelta()), Constants.NO_REPLY });
/*     */     }
/*     */     else {
/* 102 */       ByteUtils.setArguments(buf, 0, new Object[] { cmdBytes, this.keyBytes, Long.valueOf(getDelta()) });
/*     */     }
/*     */     
/* 105 */     this.ioBuffer = IoBuffer.wrap(buf);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\command\text\TextIncrDecrCommand.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */