/*     */ package net.rubyeye.xmemcached.command.text;
/*     */ 
/*     */ import com.google.code.yanf4j.buffer.IoBuffer;
/*     */ import java.net.InetSocketAddress;
/*     */ import java.nio.ByteBuffer;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ import java.util.concurrent.CountDownLatch;
/*     */ import net.rubyeye.xmemcached.command.Command;
/*     */ import net.rubyeye.xmemcached.command.CommandType;
/*     */ import net.rubyeye.xmemcached.command.ServerAddressAware;
/*     */ import net.rubyeye.xmemcached.impl.MemcachedTCPSession;
/*     */ import net.rubyeye.xmemcached.networking.MemcachedSession;
/*     */ import net.rubyeye.xmemcached.utils.ByteUtils;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class TextStatsCommand
/*     */   extends Command
/*     */   implements ServerAddressAware
/*     */ {
/*  47 */   public static final ByteBuffer STATS = ByteBuffer.wrap("stats\r\n".getBytes());
/*     */   private InetSocketAddress server;
/*     */   private String itemName;
/*     */   
/*     */   public String getItemName()
/*     */   {
/*  53 */     return this.itemName;
/*     */   }
/*     */   
/*     */   public final InetSocketAddress getServer() {
/*  57 */     return this.server;
/*     */   }
/*     */   
/*     */   public final void setServer(InetSocketAddress server) {
/*  61 */     this.server = server;
/*     */   }
/*     */   
/*     */   public void setItemName(String item) {
/*  65 */     this.itemName = item;
/*     */   }
/*     */   
/*     */   public TextStatsCommand(InetSocketAddress server, CountDownLatch latch, String itemName)
/*     */   {
/*  70 */     super("stats", (byte[])null, latch);
/*  71 */     this.commandType = CommandType.STATS;
/*  72 */     this.server = server;
/*  73 */     this.itemName = itemName;
/*  74 */     this.result = new HashMap();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public final boolean decode(MemcachedTCPSession session, ByteBuffer buffer)
/*     */   {
/*  81 */     String line = null;
/*  82 */     while ((line = ByteUtils.nextLine(buffer)) != null) {
/*  83 */       if (line.equals("END"))
/*  84 */         return done(session);
/*  85 */       if ((line.startsWith("STAT")) || (line.startsWith("PREFIX")))
/*     */       {
/*  87 */         String[] items = line.split(" ");
/*  88 */         ((Map)getResult()).put(items[1], items[2]);
/*     */       } else {
/*  90 */         return decodeError(line);
/*     */       }
/*     */     }
/*  93 */     return false;
/*     */   }
/*     */   
/*     */   private final boolean done(MemcachedSession session) {
/*  97 */     countDownLatch();
/*  98 */     return true;
/*     */   }
/*     */   
/*     */   public final void encode()
/*     */   {
/* 103 */     if (this.itemName == null) {
/* 104 */       this.ioBuffer = IoBuffer.wrap(STATS.slice());
/*     */     } else {
/* 106 */       this.ioBuffer = IoBuffer.allocate(5 + this.itemName.length() + 3);
/* 107 */       ByteUtils.setArguments(this.ioBuffer, new Object[] { "stats", this.itemName });
/* 108 */       this.ioBuffer.flip();
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\command\text\TextStatsCommand.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */