/*     */ package net.rubyeye.xmemcached.command.text;
/*     */ 
/*     */ import com.google.code.yanf4j.buffer.IoBuffer;
/*     */ import java.nio.ByteBuffer;
/*     */ import java.util.concurrent.CountDownLatch;
/*     */ import net.rubyeye.xmemcached.command.Command;
/*     */ import net.rubyeye.xmemcached.command.CommandType;
/*     */ import net.rubyeye.xmemcached.impl.MemcachedTCPSession;
/*     */ import net.rubyeye.xmemcached.monitor.Constants;
/*     */ import net.rubyeye.xmemcached.utils.ByteUtils;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class TextTouchCommand
/*     */   extends Command
/*     */ {
/*     */   private static final String NOT_FOUND = "NOT_FOUND\r\n";
/*     */   private static final String TOUCHED = "TOUCHED\r\n";
/*     */   private int expTime;
/*     */   
/*     */   public TextTouchCommand(String key, byte[] keyBytes, CommandType cmdType, CountDownLatch latch, int expTime, boolean noreply)
/*     */   {
/*  51 */     super(key, keyBytes, cmdType, latch);
/*  52 */     this.expTime = expTime;
/*  53 */     this.noreply = noreply;
/*     */   }
/*     */   
/*     */   public int getExpTime() {
/*  57 */     return this.expTime;
/*     */   }
/*     */   
/*     */   public void setExpTime(int expTime) {
/*  61 */     this.expTime = expTime;
/*     */   }
/*     */   
/*     */   public final boolean decode(MemcachedTCPSession session, ByteBuffer buffer)
/*     */   {
/*  66 */     if ((buffer == null) || (!buffer.hasRemaining())) {
/*  67 */       return false;
/*     */     }
/*  69 */     if (this.result == null) {
/*  70 */       if (buffer.remaining() < 1)
/*  71 */         return false;
/*  72 */       byte first = buffer.get(buffer.position());
/*  73 */       if (first == 84) {
/*  74 */         setResult(Boolean.TRUE);
/*  75 */         countDownLatch();
/*     */         
/*  77 */         return ByteUtils.stepBuffer(buffer, "TOUCHED\r\n".length()); }
/*  78 */       if (first == 78) {
/*  79 */         setResult(Boolean.FALSE);
/*  80 */         countDownLatch();
/*     */         
/*  82 */         return ByteUtils.stepBuffer(buffer, "NOT_FOUND\r\n".length());
/*     */       }
/*  84 */       return decodeError(session, buffer);
/*     */     }
/*     */     
/*  87 */     Boolean result = (Boolean)this.result;
/*  88 */     if (result.booleanValue()) {
/*  89 */       return ByteUtils.stepBuffer(buffer, "TOUCHED\r\n".length());
/*     */     }
/*  91 */     return ByteUtils.stepBuffer(buffer, "NOT_FOUND\r\n".length());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public final void encode()
/*     */   {
/*  98 */     byte[] cmdBytes = Constants.TOUCH;
/*  99 */     int size = 7 + this.keyBytes.length + ByteUtils.stringSize(this.expTime) + Constants.CRLF.length;
/*     */     
/* 101 */     if (isNoreply()) {
/* 102 */       size += 8;
/*     */     }
/* 104 */     byte[] buf = new byte[size];
/* 105 */     if (isNoreply()) {
/* 106 */       ByteUtils.setArguments(buf, 0, new Object[] { cmdBytes, this.keyBytes, Integer.valueOf(this.expTime), Constants.NO_REPLY });
/*     */     }
/*     */     else {
/* 109 */       ByteUtils.setArguments(buf, 0, new Object[] { cmdBytes, this.keyBytes, Integer.valueOf(this.expTime) });
/*     */     }
/*     */     
/* 112 */     this.ioBuffer = IoBuffer.wrap(buf);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\command\text\TextTouchCommand.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */