/*    */ package org.codehaus.jackson.map.type;
/*    */ 
/*    */ import java.lang.reflect.ParameterizedType;
/*    */ import java.lang.reflect.Type;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class HierarchicType
/*    */ {
/*    */   protected final Type _actualType;
/*    */   protected final Class<?> _rawClass;
/*    */   protected final ParameterizedType _genericType;
/*    */   protected HierarchicType _superType;
/*    */   protected HierarchicType _subType;
/*    */   
/*    */   public HierarchicType(Type type)
/*    */   {
/* 32 */     this._actualType = type;
/* 33 */     if ((type instanceof Class)) {
/* 34 */       this._rawClass = ((Class)type);
/* 35 */       this._genericType = null;
/* 36 */     } else if ((type instanceof ParameterizedType)) {
/* 37 */       this._genericType = ((ParameterizedType)type);
/* 38 */       this._rawClass = ((Class)this._genericType.getRawType());
/*    */     } else {
/* 40 */       throw new IllegalArgumentException("Type " + type.getClass().getName() + " can not be used to construct HierarchicType");
/*    */     }
/*    */   }
/*    */   
/* 44 */   public void setSuperType(HierarchicType sup) { this._superType = sup; }
/* 45 */   public HierarchicType getSuperType() { return this._superType; }
/* 46 */   public void setSubType(HierarchicType sub) { this._subType = sub; }
/* 47 */   public HierarchicType getSubType() { return this._subType; }
/*    */   
/* 49 */   public boolean isGeneric() { return this._genericType != null; }
/* 50 */   public ParameterizedType asGeneric() { return this._genericType; }
/*    */   
/* 52 */   public Class<?> getRawClass() { return this._rawClass; }
/*    */   
/*    */   public String toString()
/*    */   {
/* 56 */     if (this._genericType != null) {
/* 57 */       return this._genericType.toString();
/*    */     }
/* 59 */     return this._rawClass.getName();
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\type\HierarchicType.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */