/*    */ package org.codehaus.jackson.node;
/*    */ 
/*    */ import java.io.IOException;
/*    */ import org.codehaus.jackson.JsonGenerator;
/*    */ import org.codehaus.jackson.JsonNode;
/*    */ import org.codehaus.jackson.JsonProcessingException;
/*    */ import org.codehaus.jackson.JsonToken;
/*    */ import org.codehaus.jackson.map.SerializerProvider;
/*    */ import org.codehaus.jackson.map.TypeSerializer;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public final class MissingNode
/*    */   extends BaseJsonNode
/*    */ {
/* 24 */   private static final MissingNode instance = new MissingNode();
/*    */   
/*    */ 
/*    */ 
/* 28 */   public static MissingNode getInstance() { return instance; }
/*    */   
/* 30 */   public JsonToken asToken() { return JsonToken.NOT_AVAILABLE; }
/*    */   
/*    */   public boolean isMissingNode() {
/* 33 */     return true;
/*    */   }
/*    */   
/* 36 */   public String getValueAsText() { return null; }
/*    */   
/*    */   public int getValueAsInt(int defaultValue)
/*    */   {
/* 40 */     return 0;
/*    */   }
/*    */   
/*    */   public long getValueAsLong(long defaultValue) {
/* 44 */     return 0L;
/*    */   }
/*    */   
/*    */   public double getValueAsDouble(double defaultValue) {
/* 48 */     return 0.0D;
/*    */   }
/*    */   
/*    */   public JsonNode path(String fieldName) {
/* 52 */     return this;
/*    */   }
/*    */   
/* 55 */   public JsonNode path(int index) { return this; }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public final void serialize(JsonGenerator jg, SerializerProvider provider)
/*    */     throws IOException, JsonProcessingException
/*    */   {
/* 65 */     jg.writeNull();
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public void serializeWithType(JsonGenerator jg, SerializerProvider provider, TypeSerializer typeSer)
/*    */     throws IOException, JsonProcessingException
/*    */   {
/* 73 */     jg.writeNull();
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public boolean equals(Object o)
/*    */   {
/* 87 */     return o == this;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public String toString()
/*    */   {
/* 94 */     return "";
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\node\MissingNode.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */