package prefuse.data.column;

import prefuse.data.DataTypeException;
import prefuse.data.Table;
import prefuse.data.expression.Expression;

public class ColumnFactory
{
  public static final Column getColumn(Class paramClass)
  {
    return getColumn(paramClass, 0, 0, null);
  }
  
  public static final Column getColumn(Class paramClass, int paramInt)
  {
    return getColumn(paramClass, paramInt, paramInt, null);
  }
  
  public static final Column getColumn(Class paramClass, int paramInt, Object paramObject)
  {
    return getColumn(paramClass, paramInt, paramInt, paramObject);
  }
  
  public static final Column getColumn(Class paramClass, int paramInt1, int paramInt2, Object paramObject)
  {
    if (paramClass == Integer.TYPE)
    {
      if (paramObject == null) {
        return new IntColumn(paramInt1);
      }
      int i = ((Integer)paramObject).intValue();
      return new IntColumn(paramInt1, paramInt1, i);
    }
    if (paramClass == Long.TYPE)
    {
      if (paramObject == null) {
        return new LongColumn(paramInt1);
      }
      long l = ((Long)paramObject).longValue();
      return new LongColumn(paramInt1, paramInt1, l);
    }
    if (paramClass == Float.TYPE)
    {
      if (paramObject == null) {
        return new FloatColumn(paramInt1);
      }
      float f = ((Float)paramObject).floatValue();
      return new FloatColumn(paramInt1, paramInt1, f);
    }
    if (paramClass == Double.TYPE)
    {
      if (paramObject == null) {
        return new DoubleColumn(paramInt1);
      }
      double d = ((Double)paramObject).doubleValue();
      return new DoubleColumn(paramInt1, paramInt1, d);
    }
    if (paramClass == Boolean.TYPE)
    {
      if (paramObject == null) {
        return new BooleanColumn(paramInt1);
      }
      boolean bool = ((Boolean)paramObject).booleanValue();
      return new BooleanColumn(paramInt1, paramInt1, bool);
    }
    if ((paramClass == Byte.TYPE) || (paramClass == Short.TYPE) || (paramClass == Character.TYPE) || (paramClass == Void.TYPE)) {
      throw new DataTypeException(paramClass);
    }
    return new ObjectColumn(paramClass, paramInt1, paramInt1, paramObject);
  }
  
  public static final Column getColumn(Table paramTable, Expression paramExpression)
  {
    return new ExpressionColumn(paramTable, paramExpression);
  }
  
  public static final Column getConstantColumn(Class paramClass, Object paramObject)
  {
    return new ConstantColumn(paramClass, paramObject);
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\column\ColumnFactory.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */