package prefuse.data.parser;

import java.text.DateFormat;
import java.text.ParsePosition;
import java.util.Date;

public class DateTimeParser
  implements DataParser
{
  protected DateFormat m_dfmt;
  protected ParsePosition m_pos;
  
  public DateTimeParser()
  {
    this(DateFormat.getDateTimeInstance(3, 3));
  }
  
  public DateTimeParser(DateFormat paramDateFormat)
  {
    this.m_dfmt = paramDateFormat;
    this.m_pos = new ParsePosition(0);
  }
  
  public Class getType()
  {
    return Date.class;
  }
  
  public boolean canParse(String paramString)
  {
    try
    {
      parseDate(paramString);
      return true;
    }
    catch (DataParseException localDataParseException) {}
    return false;
  }
  
  public Object parse(String paramString)
    throws DataParseException
  {
    return parseDate(paramString);
  }
  
  public Date parseDate(String paramString)
    throws DataParseException
  {
    this.m_pos.setErrorIndex(0);
    this.m_pos.setIndex(0);
    Date localDate = this.m_dfmt.parse(paramString, this.m_pos);
    if ((localDate == null) || (this.m_pos.getIndex() < paramString.length())) {
      throw new DataParseException("Could not parse Date: " + paramString);
    }
    return localDate;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\parser\DateTimeParser.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */