package prefuse.util;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.Comparator;
import java.util.Random;
import java.util.StringTokenizer;

public abstract class ArrayLib
{
  public static final int SORT_THRESHOLD = 30;
  
  public static final void shuffle(int[] paramArrayOfInt, Random paramRandom)
  {
    shuffle(paramArrayOfInt, 0, paramArrayOfInt.length, paramRandom);
  }
  
  public static final void shuffle(int[] paramArrayOfInt, int paramInt1, int paramInt2, Random paramRandom)
  {
    int i = paramInt1 + paramInt2;
    for (;;)
    {
      i--;
      if (i <= 0) {
        break;
      }
      int j = paramArrayOfInt[i];
      int k = paramRandom.nextInt(i);
      paramArrayOfInt[i] = paramArrayOfInt[k];
      paramArrayOfInt[k] = j;
    }
  }
  
  public static final void shuffle(long[] paramArrayOfLong, Random paramRandom)
  {
    shuffle(paramArrayOfLong, 0, paramArrayOfLong.length, paramRandom);
  }
  
  public static final void shuffle(long[] paramArrayOfLong, int paramInt1, int paramInt2, Random paramRandom)
  {
    for (int i = paramInt1 + paramInt2; i > 1; i--)
    {
      long l = paramArrayOfLong[i];
      int j = paramRandom.nextInt(i);
      paramArrayOfLong[i] = paramArrayOfLong[j];
      paramArrayOfLong[j] = l;
    }
  }
  
  public static final void shuffle(float[] paramArrayOfFloat, Random paramRandom)
  {
    shuffle(paramArrayOfFloat, 0, paramArrayOfFloat.length, paramRandom);
  }
  
  public static final void shuffle(float[] paramArrayOfFloat, int paramInt1, int paramInt2, Random paramRandom)
  {
    for (int i = paramInt1 + paramInt2; i > 1; i--)
    {
      float f = paramArrayOfFloat[i];
      int j = paramRandom.nextInt(i);
      paramArrayOfFloat[i] = paramArrayOfFloat[j];
      paramArrayOfFloat[j] = f;
    }
  }
  
  public static final void shuffle(double[] paramArrayOfDouble, Random paramRandom)
  {
    shuffle(paramArrayOfDouble, 0, paramArrayOfDouble.length, paramRandom);
  }
  
  public static final void shuffle(double[] paramArrayOfDouble, int paramInt1, int paramInt2, Random paramRandom)
  {
    for (int i = paramInt1 + paramInt2; i > 1; i--)
    {
      double d = paramArrayOfDouble[i];
      int j = paramRandom.nextInt(i);
      paramArrayOfDouble[i] = paramArrayOfDouble[j];
      paramArrayOfDouble[j] = d;
    }
  }
  
  public static final void shuffle(Object[] paramArrayOfObject, Random paramRandom)
  {
    shuffle(paramArrayOfObject, 0, paramArrayOfObject.length, paramRandom);
  }
  
  public static final void shuffle(Object[] paramArrayOfObject, int paramInt1, int paramInt2, Random paramRandom)
  {
    for (int i = paramInt1 + paramInt2; i > 1; i--)
    {
      Object localObject = paramArrayOfObject[i];
      int j = paramRandom.nextInt(i);
      paramArrayOfObject[i] = paramArrayOfObject[j];
      paramArrayOfObject[j] = localObject;
    }
  }
  
  public static final double max(double[] paramArrayOfDouble)
  {
    double d = Double.NEGATIVE_INFINITY;
    for (int i = 0; i < paramArrayOfDouble.length; i++) {
      if (paramArrayOfDouble[i] > d) {
        d = paramArrayOfDouble[i];
      }
    }
    return d;
  }
  
  public static final double min(double[] paramArrayOfDouble)
  {
    double d = Double.POSITIVE_INFINITY;
    for (int i = 0; i < paramArrayOfDouble.length; i++) {
      if (paramArrayOfDouble[i] < d) {
        d = paramArrayOfDouble[i];
      }
    }
    return d;
  }
  
  public static final int binarySearch(int[] paramArrayOfInt, int paramInt)
  {
    int i = 0;
    int j = paramArrayOfInt.length;
    for (int k = j / 2; i < j; k = i + (j - i) / 2)
    {
      if (paramArrayOfInt[k] == paramInt) {
        return k;
      }
      if (paramArrayOfInt[k] < paramInt) {
        i = k + 1;
      } else {
        j = k;
      }
    }
    return -1 * (k + 1);
  }
  
  public static final int binarySearch(int[] paramArrayOfInt, int paramInt1, int paramInt2)
  {
    int i = 0;
    int j = paramInt2;
    for (int k = j / 2; i < j; k = i + (j - i) / 2)
    {
      if (paramArrayOfInt[k] == paramInt1) {
        return k;
      }
      if (paramArrayOfInt[k] < paramInt1) {
        i = k + 1;
      } else {
        j = k;
      }
    }
    return -1 * (k + 1);
  }
  
  public static final int binarySearch(int[] paramArrayOfInt, int paramInt1, int paramInt2, int paramInt3)
  {
    int i = paramInt2;
    int j = paramInt3;
    for (int k = i + (j - i) / 2; i < j; k = i + (j - i) / 2)
    {
      if (paramArrayOfInt[k] == paramInt1) {
        return k;
      }
      if (paramArrayOfInt[k] < paramInt1) {
        i = k + 1;
      } else {
        j = k;
      }
    }
    return -1 * (k + 1);
  }
  
  public static final int binarySearch(Object[] paramArrayOfObject, Object paramObject)
  {
    int i = 0;
    int j = paramArrayOfObject.length;
    for (int k = j / 2; i < j; k = i + (j - i) / 2)
    {
      int m = ((Comparable)paramArrayOfObject[k]).compareTo(paramObject);
      if (m == 0) {
        return k;
      }
      if (m < 0) {
        i = k + 1;
      } else {
        j = k;
      }
    }
    return -1 * (k + 1);
  }
  
  public static final int binarySearch(Object[] paramArrayOfObject, Object paramObject, int paramInt)
  {
    int i = 0;
    int j = paramInt;
    for (int k = j / 2; i < j; k = i + (j - i) / 2)
    {
      int m = ((Comparable)paramArrayOfObject[k]).compareTo(paramObject);
      if (m == 0) {
        return k;
      }
      if (m < 0) {
        i = k + 1;
      } else {
        j = k;
      }
    }
    return -1 * (k + 1);
  }
  
  public static final int binarySearch(Object[] paramArrayOfObject, Object paramObject, int paramInt1, int paramInt2)
  {
    int i = paramInt1;
    int j = paramInt2;
    for (int k = i + (j - i) / 2; i < j; k = i + (j - i) / 2)
    {
      int m = ((Comparable)paramArrayOfObject[k]).compareTo(paramObject);
      if (m == 0) {
        return k;
      }
      if (m < 0) {
        i = k + 1;
      } else {
        j = k;
      }
    }
    return -1 * (k + 1);
  }
  
  public static final int binarySearch(Object[] paramArrayOfObject, Object paramObject, Comparator paramComparator)
  {
    int i = 0;
    int j = paramArrayOfObject.length;
    for (int k = j / 2; i < j; k = i + (j - i) / 2)
    {
      int m = paramComparator.compare(paramArrayOfObject[k], paramObject);
      if (m == 0) {
        return k;
      }
      if (m < 0) {
        i = k + 1;
      } else {
        j = k;
      }
    }
    return -1 * (k + 1);
  }
  
  public static final int binarySearch(Object[] paramArrayOfObject, Object paramObject, Comparator paramComparator, int paramInt)
  {
    int i = 0;
    int j = paramInt;
    for (int k = j / 2; i < j; k = i + (j - i) / 2)
    {
      int m = paramComparator.compare(paramArrayOfObject[k], paramObject);
      if (m == 0) {
        return k;
      }
      if (m < 0) {
        i = k + 1;
      } else {
        j = k;
      }
    }
    return -1 * (k + 1);
  }
  
  public static final int binarySearch(Object[] paramArrayOfObject, Object paramObject, Comparator paramComparator, int paramInt1, int paramInt2)
  {
    int i = paramInt1;
    int j = paramInt2;
    for (int k = i + (j - i) / 2; i < j; k = i + (j - i) / 2)
    {
      int m = paramComparator.compare(paramArrayOfObject[k], paramObject);
      if (m == 0) {
        return k;
      }
      if (m < 0) {
        i = k + 1;
      } else {
        j = k;
      }
    }
    return -1 * (k + 1);
  }
  
  public static final int find(int[] paramArrayOfInt, int paramInt)
  {
    for (int i = 0; i < paramArrayOfInt.length; i++) {
      if (paramArrayOfInt[i] == paramInt) {
        return i;
      }
    }
    return -1;
  }
  
  public static final int find(int[] paramArrayOfInt, int paramInt1, int paramInt2)
  {
    for (int i = 0; i < paramInt2; i++) {
      if (paramArrayOfInt[i] == paramInt1) {
        return i;
      }
    }
    return -1;
  }
  
  public static final int find(int[] paramArrayOfInt, int paramInt1, int paramInt2, int paramInt3)
  {
    for (int i = paramInt2; i < paramInt3; i++) {
      if (paramArrayOfInt[i] == paramInt1) {
        return i;
      }
    }
    return -1;
  }
  
  public static final int[] resize(int[] paramArrayOfInt, int paramInt)
  {
    if (paramArrayOfInt.length >= paramInt) {
      return paramArrayOfInt;
    }
    int[] arrayOfInt = new int[paramInt];
    System.arraycopy(paramArrayOfInt, 0, arrayOfInt, 0, paramArrayOfInt.length);
    return arrayOfInt;
  }
  
  public static final float[] resize(float[] paramArrayOfFloat, int paramInt)
  {
    if (paramArrayOfFloat.length >= paramInt) {
      return paramArrayOfFloat;
    }
    float[] arrayOfFloat = new float[paramInt];
    System.arraycopy(paramArrayOfFloat, 0, arrayOfFloat, 0, paramArrayOfFloat.length);
    return arrayOfFloat;
  }
  
  public static final double[] resize(double[] paramArrayOfDouble, int paramInt)
  {
    if (paramArrayOfDouble.length >= paramInt) {
      return paramArrayOfDouble;
    }
    double[] arrayOfDouble = new double[paramInt];
    System.arraycopy(paramArrayOfDouble, 0, arrayOfDouble, 0, paramArrayOfDouble.length);
    return arrayOfDouble;
  }
  
  public static final Object[] resize(Object[] paramArrayOfObject, int paramInt)
  {
    if (paramArrayOfObject.length >= paramInt) {
      return paramArrayOfObject;
    }
    Object[] arrayOfObject = new Object[paramInt];
    System.arraycopy(paramArrayOfObject, 0, arrayOfObject, 0, paramArrayOfObject.length);
    return arrayOfObject;
  }
  
  public static final int[] trim(int[] paramArrayOfInt, int paramInt)
  {
    if (paramArrayOfInt.length == paramInt) {
      return paramArrayOfInt;
    }
    int[] arrayOfInt = new int[paramInt];
    System.arraycopy(paramArrayOfInt, 0, arrayOfInt, 0, paramInt);
    return arrayOfInt;
  }
  
  public static final float[] trim(float[] paramArrayOfFloat, int paramInt)
  {
    if (paramArrayOfFloat.length == paramInt) {
      return paramArrayOfFloat;
    }
    float[] arrayOfFloat = new float[paramInt];
    System.arraycopy(paramArrayOfFloat, 0, arrayOfFloat, 0, paramInt);
    return arrayOfFloat;
  }
  
  public static final double[] trim(double[] paramArrayOfDouble, int paramInt)
  {
    if (paramArrayOfDouble.length == paramInt) {
      return paramArrayOfDouble;
    }
    double[] arrayOfDouble = new double[paramInt];
    System.arraycopy(paramArrayOfDouble, 0, arrayOfDouble, 0, paramInt);
    return arrayOfDouble;
  }
  
  public static final void sort(int[] paramArrayOfInt, double[] paramArrayOfDouble)
  {
    mergesort(paramArrayOfInt, paramArrayOfDouble, 0, paramArrayOfInt.length - 1);
  }
  
  public static final void sort(int[] paramArrayOfInt, double[] paramArrayOfDouble, int paramInt)
  {
    mergesort(paramArrayOfInt, paramArrayOfDouble, 0, paramInt - 1);
  }
  
  public static final void sort(int[] paramArrayOfInt, double[] paramArrayOfDouble, int paramInt1, int paramInt2)
  {
    mergesort(paramArrayOfInt, paramArrayOfDouble, paramInt1, paramInt2 - 1);
  }
  
  protected static final void insertionsort(int[] paramArrayOfInt, double[] paramArrayOfDouble, int paramInt1, int paramInt2)
  {
    for (int i = paramInt1 + 1; i <= paramInt2; i++)
    {
      int j = paramArrayOfInt[i];
      double d = paramArrayOfDouble[i];
      for (int k = i - 1; (k >= paramInt1) && (paramArrayOfInt[k] > j); k--)
      {
        paramArrayOfInt[(k + 1)] = paramArrayOfInt[k];
        paramArrayOfDouble[(k + 1)] = paramArrayOfDouble[k];
      }
      paramArrayOfInt[(k + 1)] = j;
      paramArrayOfDouble[(k + 1)] = d;
    }
  }
  
  protected static final void mergesort(int[] paramArrayOfInt, double[] paramArrayOfDouble, int paramInt1, int paramInt2)
  {
    if (paramInt1 >= paramInt2) {
      return;
    }
    if (paramInt2 - paramInt1 + 1 < 30)
    {
      insertionsort(paramArrayOfInt, paramArrayOfDouble, paramInt1, paramInt2);
    }
    else
    {
      int i = (paramInt1 + paramInt2) / 2;
      mergesort(paramArrayOfInt, paramArrayOfDouble, paramInt1, i);
      mergesort(paramArrayOfInt, paramArrayOfDouble, i + 1, paramInt2);
      merge(paramArrayOfInt, paramArrayOfDouble, paramInt1, i, paramInt2);
    }
  }
  
  protected static final void merge(int[] paramArrayOfInt, double[] paramArrayOfDouble, int paramInt1, int paramInt2, int paramInt3)
  {
    int[] arrayOfInt = new int[paramInt3 - paramInt1 + 1];
    double[] arrayOfDouble = new double[paramInt3 - paramInt1 + 1];
    int j = paramInt1;
    int k = paramInt2 + 1;
    for (int i = 0; (j <= paramInt2) && (k <= paramInt3); i++) {
      if (paramArrayOfInt[j] < paramArrayOfInt[k])
      {
        arrayOfDouble[i] = paramArrayOfDouble[j];
        arrayOfInt[i] = paramArrayOfInt[(j++)];
      }
      else
      {
        arrayOfDouble[i] = paramArrayOfDouble[k];
        arrayOfInt[i] = paramArrayOfInt[(k++)];
      }
    }
    while (j <= paramInt2)
    {
      arrayOfDouble[i] = paramArrayOfDouble[j];
      arrayOfInt[i] = paramArrayOfInt[j];
      j++;
      i++;
    }
    while (k <= paramInt3)
    {
      arrayOfDouble[i] = paramArrayOfDouble[k];
      arrayOfInt[i] = paramArrayOfInt[k];
      k++;
      i++;
    }
    i = 0;
    for (j = paramInt1; i < arrayOfInt.length; j++)
    {
      paramArrayOfDouble[j] = arrayOfDouble[i];
      paramArrayOfInt[j] = arrayOfInt[i];
      i++;
    }
  }
  
  public static final void sort(int[] paramArrayOfInt1, int[] paramArrayOfInt2)
  {
    mergesort(paramArrayOfInt1, paramArrayOfInt2, 0, paramArrayOfInt1.length - 1);
  }
  
  public static final void sort(int[] paramArrayOfInt1, int[] paramArrayOfInt2, int paramInt)
  {
    mergesort(paramArrayOfInt1, paramArrayOfInt2, 0, paramInt - 1);
  }
  
  public static final void sort(int[] paramArrayOfInt1, int[] paramArrayOfInt2, int paramInt1, int paramInt2)
  {
    mergesort(paramArrayOfInt1, paramArrayOfInt2, paramInt1, paramInt2 - 1);
  }
  
  protected static final void insertionsort(int[] paramArrayOfInt1, int[] paramArrayOfInt2, int paramInt1, int paramInt2)
  {
    for (int i = paramInt1 + 1; i <= paramInt2; i++)
    {
      int j = paramArrayOfInt1[i];
      int k = paramArrayOfInt2[i];
      for (int m = i - 1; (m >= paramInt1) && (paramArrayOfInt1[m] > j); m--)
      {
        paramArrayOfInt1[(m + 1)] = paramArrayOfInt1[m];
        paramArrayOfInt2[(m + 1)] = paramArrayOfInt2[m];
      }
      paramArrayOfInt1[(m + 1)] = j;
      paramArrayOfInt2[(m + 1)] = k;
    }
  }
  
  protected static final void mergesort(int[] paramArrayOfInt1, int[] paramArrayOfInt2, int paramInt1, int paramInt2)
  {
    if (paramInt1 >= paramInt2) {
      return;
    }
    if (paramInt2 - paramInt1 + 1 < 30)
    {
      insertionsort(paramArrayOfInt1, paramArrayOfInt2, paramInt1, paramInt2);
    }
    else
    {
      int i = (paramInt1 + paramInt2) / 2;
      mergesort(paramArrayOfInt1, paramArrayOfInt2, paramInt1, i);
      mergesort(paramArrayOfInt1, paramArrayOfInt2, i + 1, paramInt2);
      merge(paramArrayOfInt1, paramArrayOfInt2, paramInt1, i, paramInt2);
    }
  }
  
  protected static final void merge(int[] paramArrayOfInt1, int[] paramArrayOfInt2, int paramInt1, int paramInt2, int paramInt3)
  {
    int[] arrayOfInt1 = new int[paramInt3 - paramInt1 + 1];
    int[] arrayOfInt2 = new int[paramInt3 - paramInt1 + 1];
    int j = paramInt1;
    int k = paramInt2 + 1;
    for (int i = 0; (j <= paramInt2) && (k <= paramInt3); i++) {
      if (paramArrayOfInt1[j] < paramArrayOfInt1[k])
      {
        arrayOfInt2[i] = paramArrayOfInt2[j];
        arrayOfInt1[i] = paramArrayOfInt1[(j++)];
      }
      else
      {
        arrayOfInt2[i] = paramArrayOfInt2[k];
        arrayOfInt1[i] = paramArrayOfInt1[(k++)];
      }
    }
    while (j <= paramInt2)
    {
      arrayOfInt2[i] = paramArrayOfInt2[j];
      arrayOfInt1[i] = paramArrayOfInt1[j];
      j++;
      i++;
    }
    while (k <= paramInt3)
    {
      arrayOfInt2[i] = paramArrayOfInt2[k];
      arrayOfInt1[i] = paramArrayOfInt1[k];
      k++;
      i++;
    }
    i = 0;
    for (j = paramInt1; i < arrayOfInt1.length; j++)
    {
      paramArrayOfInt2[j] = arrayOfInt2[i];
      paramArrayOfInt1[j] = arrayOfInt1[i];
      i++;
    }
  }
  
  public static final void sort(int[] paramArrayOfInt, Object[] paramArrayOfObject, int paramInt1, int paramInt2)
  {
    int i = paramInt2 - paramInt1;
    if (i < 30)
    {
      insertionsort(paramArrayOfInt, paramArrayOfObject, paramInt1, paramInt2 - 1);
      return;
    }
    int[] arrayOfInt = new int[i];
    Object[] arrayOfObject = new Object[i];
    int j = 0;
    for (int k = paramInt1; j < i; k++)
    {
      arrayOfInt[j] = paramArrayOfInt[k];
      arrayOfObject[j] = paramArrayOfObject[k];
      j++;
    }
    mergesort(arrayOfInt, paramArrayOfInt, arrayOfObject, paramArrayOfObject, paramInt1, paramInt2, -paramInt1);
  }
  
  public static final void sort(int[] paramArrayOfInt1, Object[] paramArrayOfObject1, int[] paramArrayOfInt2, Object[] paramArrayOfObject2, int paramInt1, int paramInt2)
  {
    int i = paramInt2 - paramInt1;
    if (i < 30)
    {
      insertionsort(paramArrayOfInt1, paramArrayOfObject1, paramInt1, paramInt2 - 1);
      return;
    }
    int j = 0;
    for (int k = paramInt1; j < i; k++)
    {
      paramArrayOfInt2[j] = paramArrayOfInt1[k];
      paramArrayOfObject2[j] = paramArrayOfObject1[k];
      j++;
    }
    mergesort(paramArrayOfInt2, paramArrayOfInt1, paramArrayOfObject2, paramArrayOfObject1, paramInt1, paramInt2, -paramInt1);
  }
  
  protected static final void insertionsort(int[] paramArrayOfInt, Object[] paramArrayOfObject, int paramInt1, int paramInt2)
  {
    for (int k = paramInt1 + 1; k <= paramInt2; k++)
    {
      int j = paramArrayOfInt[k];
      Object localObject = paramArrayOfObject[k];
      for (int i = k - 1; (i >= paramInt1) && (paramArrayOfInt[i] > j); i--)
      {
        paramArrayOfInt[(i + 1)] = paramArrayOfInt[i];
        paramArrayOfObject[(i + 1)] = paramArrayOfObject[i];
      }
      paramArrayOfInt[(i + 1)] = j;
      paramArrayOfObject[(i + 1)] = localObject;
    }
  }
  
  protected static void mergesort(int[] paramArrayOfInt1, int[] paramArrayOfInt2, Object[] paramArrayOfObject1, Object[] paramArrayOfObject2, int paramInt1, int paramInt2, int paramInt3)
  {
    int i = paramInt2 - paramInt1;
    if (i < 30)
    {
      insertionsort(paramArrayOfInt2, paramArrayOfObject2, paramInt1, paramInt2 - 1);
      return;
    }
    int j = paramInt1;
    int k = paramInt2;
    paramInt1 += paramInt3;
    paramInt2 += paramInt3;
    int m = paramInt1 + paramInt2 >> 1;
    mergesort(paramArrayOfInt2, paramArrayOfInt1, paramArrayOfObject2, paramArrayOfObject1, paramInt1, m, -paramInt3);
    mergesort(paramArrayOfInt2, paramArrayOfInt1, paramArrayOfObject2, paramArrayOfObject1, m, paramInt2, -paramInt3);
    if (paramArrayOfInt1[(m - 1)] <= paramArrayOfInt1[m])
    {
      System.arraycopy(paramArrayOfInt1, paramInt1, paramArrayOfInt2, j, i);
      System.arraycopy(paramArrayOfObject1, paramInt1, paramArrayOfObject2, j, i);
      return;
    }
    int n = j;
    int i1 = paramInt1;
    int i2 = m;
    while (n < k)
    {
      if ((i2 >= paramInt2) || ((i1 < m) && (paramArrayOfInt1[i1] <= paramArrayOfInt1[i2])))
      {
        paramArrayOfObject2[n] = paramArrayOfObject1[i1];
        paramArrayOfInt2[n] = paramArrayOfInt1[(i1++)];
      }
      else
      {
        paramArrayOfObject2[n] = paramArrayOfObject1[i2];
        paramArrayOfInt2[n] = paramArrayOfInt1[(i2++)];
      }
      n++;
    }
  }
  
  protected static final void merge(int[] paramArrayOfInt, Object[] paramArrayOfObject, int paramInt1, int paramInt2, int paramInt3)
  {
    int[] arrayOfInt = new int[paramInt3 - paramInt1 + 1];
    Object[] arrayOfObject = new Object[paramInt3 - paramInt1 + 1];
    int j = paramInt1;
    int k = paramInt2 + 1;
    for (int i = 0; (j <= paramInt2) && (k <= paramInt3); i++) {
      if (paramArrayOfInt[j] < paramArrayOfInt[k])
      {
        arrayOfObject[i] = paramArrayOfObject[j];
        arrayOfInt[i] = paramArrayOfInt[(j++)];
      }
      else
      {
        arrayOfObject[i] = paramArrayOfObject[k];
        arrayOfInt[i] = paramArrayOfInt[(k++)];
      }
    }
    while (j <= paramInt2)
    {
      arrayOfObject[i] = paramArrayOfObject[j];
      arrayOfInt[i] = paramArrayOfInt[j];
      j++;
      i++;
    }
    while (k <= paramInt3)
    {
      arrayOfObject[i] = paramArrayOfObject[k];
      arrayOfInt[i] = paramArrayOfInt[k];
      k++;
      i++;
    }
    i = 0;
    for (j = paramInt1; i < arrayOfInt.length; j++)
    {
      paramArrayOfObject[j] = arrayOfObject[i];
      paramArrayOfInt[j] = arrayOfInt[i];
      i++;
    }
  }
  
  public static final void sort(double[] paramArrayOfDouble, int[] paramArrayOfInt)
  {
    mergesort(paramArrayOfDouble, paramArrayOfInt, 0, paramArrayOfDouble.length - 1);
  }
  
  public static final void sort(double[] paramArrayOfDouble, int[] paramArrayOfInt, int paramInt)
  {
    mergesort(paramArrayOfDouble, paramArrayOfInt, 0, paramInt - 1);
  }
  
  public static final void sort(double[] paramArrayOfDouble, int[] paramArrayOfInt, int paramInt1, int paramInt2)
  {
    mergesort(paramArrayOfDouble, paramArrayOfInt, paramInt1, paramInt2 - 1);
  }
  
  protected static final void insertionsort(double[] paramArrayOfDouble, int[] paramArrayOfInt, int paramInt1, int paramInt2)
  {
    for (int i = paramInt1 + 1; i <= paramInt2; i++)
    {
      double d = paramArrayOfDouble[i];
      int j = paramArrayOfInt[i];
      for (int k = i - 1; (k >= paramInt1) && (paramArrayOfDouble[k] > d); k--)
      {
        paramArrayOfDouble[(k + 1)] = paramArrayOfDouble[k];
        paramArrayOfInt[(k + 1)] = paramArrayOfInt[k];
      }
      paramArrayOfDouble[(k + 1)] = d;
      paramArrayOfInt[(k + 1)] = j;
    }
  }
  
  protected static final void mergesort(double[] paramArrayOfDouble, int[] paramArrayOfInt, int paramInt1, int paramInt2)
  {
    if (paramInt1 >= paramInt2) {
      return;
    }
    if (paramInt2 - paramInt1 + 1 < 30)
    {
      insertionsort(paramArrayOfDouble, paramArrayOfInt, paramInt1, paramInt2);
    }
    else
    {
      int i = (paramInt1 + paramInt2) / 2;
      mergesort(paramArrayOfDouble, paramArrayOfInt, paramInt1, i);
      mergesort(paramArrayOfDouble, paramArrayOfInt, i + 1, paramInt2);
      merge(paramArrayOfDouble, paramArrayOfInt, paramInt1, i, paramInt2);
    }
  }
  
  protected static final void merge(double[] paramArrayOfDouble, int[] paramArrayOfInt, int paramInt1, int paramInt2, int paramInt3)
  {
    double[] arrayOfDouble = new double[paramInt3 - paramInt1 + 1];
    int[] arrayOfInt = new int[paramInt3 - paramInt1 + 1];
    int j = paramInt1;
    int k = paramInt2 + 1;
    for (int i = 0; (j <= paramInt2) && (k <= paramInt3); i++) {
      if (paramArrayOfDouble[j] < paramArrayOfDouble[k])
      {
        arrayOfInt[i] = paramArrayOfInt[j];
        arrayOfDouble[i] = paramArrayOfDouble[(j++)];
      }
      else
      {
        arrayOfInt[i] = paramArrayOfInt[k];
        arrayOfDouble[i] = paramArrayOfDouble[(k++)];
      }
    }
    while (j <= paramInt2)
    {
      arrayOfInt[i] = paramArrayOfInt[j];
      arrayOfDouble[i] = paramArrayOfDouble[j];
      j++;
      i++;
    }
    while (k <= paramInt3)
    {
      arrayOfInt[i] = paramArrayOfInt[k];
      arrayOfDouble[i] = paramArrayOfDouble[k];
      k++;
      i++;
    }
    i = 0;
    for (j = paramInt1; i < arrayOfDouble.length; j++)
    {
      paramArrayOfInt[j] = arrayOfInt[i];
      paramArrayOfDouble[j] = arrayOfDouble[i];
      i++;
    }
  }
  
  public static final void sort(float[] paramArrayOfFloat, int[] paramArrayOfInt)
  {
    mergesort(paramArrayOfFloat, paramArrayOfInt, 0, paramArrayOfFloat.length - 1);
  }
  
  public static final void sort(float[] paramArrayOfFloat, int[] paramArrayOfInt, int paramInt)
  {
    mergesort(paramArrayOfFloat, paramArrayOfInt, 0, paramInt - 1);
  }
  
  public static final void sort(float[] paramArrayOfFloat, int[] paramArrayOfInt, int paramInt1, int paramInt2)
  {
    mergesort(paramArrayOfFloat, paramArrayOfInt, paramInt1, paramInt2 - 1);
  }
  
  protected static final void insertionsort(float[] paramArrayOfFloat, int[] paramArrayOfInt, int paramInt1, int paramInt2)
  {
    for (int i = paramInt1 + 1; i <= paramInt2; i++)
    {
      float f = paramArrayOfFloat[i];
      int j = paramArrayOfInt[i];
      for (int k = i - 1; (k >= paramInt1) && (paramArrayOfFloat[k] > f); k--)
      {
        paramArrayOfFloat[(k + 1)] = paramArrayOfFloat[k];
        paramArrayOfInt[(k + 1)] = paramArrayOfInt[k];
      }
      paramArrayOfFloat[(k + 1)] = f;
      paramArrayOfInt[(k + 1)] = j;
    }
  }
  
  protected static final void mergesort(float[] paramArrayOfFloat, int[] paramArrayOfInt, int paramInt1, int paramInt2)
  {
    if (paramInt1 >= paramInt2) {
      return;
    }
    if (paramInt2 - paramInt1 + 1 < 30)
    {
      insertionsort(paramArrayOfFloat, paramArrayOfInt, paramInt1, paramInt2);
    }
    else
    {
      int i = (paramInt1 + paramInt2) / 2;
      mergesort(paramArrayOfFloat, paramArrayOfInt, paramInt1, i);
      mergesort(paramArrayOfFloat, paramArrayOfInt, i + 1, paramInt2);
      merge(paramArrayOfFloat, paramArrayOfInt, paramInt1, i, paramInt2);
    }
  }
  
  protected static final void merge(float[] paramArrayOfFloat, int[] paramArrayOfInt, int paramInt1, int paramInt2, int paramInt3)
  {
    float[] arrayOfFloat = new float[paramInt3 - paramInt1 + 1];
    int[] arrayOfInt = new int[paramInt3 - paramInt1 + 1];
    int j = paramInt1;
    int k = paramInt2 + 1;
    for (int i = 0; (j <= paramInt2) && (k <= paramInt3); i++) {
      if (paramArrayOfFloat[j] < paramArrayOfFloat[k])
      {
        arrayOfInt[i] = paramArrayOfInt[j];
        arrayOfFloat[i] = paramArrayOfFloat[(j++)];
      }
      else
      {
        arrayOfInt[i] = paramArrayOfInt[k];
        arrayOfFloat[i] = paramArrayOfFloat[(k++)];
      }
    }
    while (j <= paramInt2)
    {
      arrayOfInt[i] = paramArrayOfInt[j];
      arrayOfFloat[i] = paramArrayOfFloat[j];
      j++;
      i++;
    }
    while (k <= paramInt3)
    {
      arrayOfInt[i] = paramArrayOfInt[k];
      arrayOfFloat[i] = paramArrayOfFloat[k];
      k++;
      i++;
    }
    i = 0;
    for (j = paramInt1; i < arrayOfFloat.length; j++)
    {
      paramArrayOfInt[j] = arrayOfInt[i];
      paramArrayOfFloat[j] = arrayOfFloat[i];
      i++;
    }
  }
  
  public static final void sort(Object[] paramArrayOfObject, int[] paramArrayOfInt, Comparator paramComparator)
  {
    mergesort(paramArrayOfObject, paramArrayOfInt, 0, paramArrayOfObject.length - 1, paramComparator);
  }
  
  public static final void sort(Object[] paramArrayOfObject, int[] paramArrayOfInt, int paramInt, Comparator paramComparator)
  {
    mergesort(paramArrayOfObject, paramArrayOfInt, 0, paramInt - 1, paramComparator);
  }
  
  public static final void sort(Object[] paramArrayOfObject, int[] paramArrayOfInt, int paramInt1, int paramInt2, Comparator paramComparator)
  {
    mergesort(paramArrayOfObject, paramArrayOfInt, paramInt1, paramInt2 - 1, paramComparator);
  }
  
  protected static final void insertionsort(Object[] paramArrayOfObject, int[] paramArrayOfInt, int paramInt1, int paramInt2, Comparator paramComparator)
  {
    for (int i = paramInt1 + 1; i <= paramInt2; i++)
    {
      Object localObject = paramArrayOfObject[i];
      int j = paramArrayOfInt[i];
      for (int k = i - 1; (k >= paramInt1) && (paramComparator.compare(paramArrayOfObject[k], localObject) > 0); k--)
      {
        paramArrayOfObject[(k + 1)] = paramArrayOfObject[k];
        paramArrayOfInt[(k + 1)] = paramArrayOfInt[k];
      }
      paramArrayOfObject[(k + 1)] = localObject;
      paramArrayOfInt[(k + 1)] = j;
    }
  }
  
  protected static final void mergesort(Object[] paramArrayOfObject, int[] paramArrayOfInt, int paramInt1, int paramInt2, Comparator paramComparator)
  {
    if (paramInt1 >= paramInt2) {
      return;
    }
    if (paramInt2 - paramInt1 + 1 < 30)
    {
      insertionsort(paramArrayOfObject, paramArrayOfInt, paramInt1, paramInt2, paramComparator);
    }
    else
    {
      int i = (paramInt1 + paramInt2) / 2;
      mergesort(paramArrayOfObject, paramArrayOfInt, paramInt1, i, paramComparator);
      mergesort(paramArrayOfObject, paramArrayOfInt, i + 1, paramInt2, paramComparator);
      merge(paramArrayOfObject, paramArrayOfInt, paramInt1, i, paramInt2, paramComparator);
    }
  }
  
  protected static final void merge(Object[] paramArrayOfObject, int[] paramArrayOfInt, int paramInt1, int paramInt2, int paramInt3, Comparator paramComparator)
  {
    Object[] arrayOfObject = new Object[paramInt3 - paramInt1 + 1];
    int[] arrayOfInt = new int[paramInt3 - paramInt1 + 1];
    int j = paramInt1;
    int k = paramInt2 + 1;
    for (int i = 0; (j <= paramInt2) && (k <= paramInt3); i++) {
      if (paramComparator.compare(paramArrayOfObject[j], paramArrayOfObject[k]) < 0)
      {
        arrayOfInt[i] = paramArrayOfInt[j];
        arrayOfObject[i] = paramArrayOfObject[(j++)];
      }
      else
      {
        arrayOfInt[i] = paramArrayOfInt[k];
        arrayOfObject[i] = paramArrayOfObject[(k++)];
      }
    }
    while (j <= paramInt2)
    {
      arrayOfInt[i] = paramArrayOfInt[j];
      arrayOfObject[i] = paramArrayOfObject[j];
      j++;
      i++;
    }
    while (k <= paramInt3)
    {
      arrayOfInt[i] = paramArrayOfInt[k];
      arrayOfObject[i] = paramArrayOfObject[k];
      k++;
      i++;
    }
    i = 0;
    for (j = paramInt1; i < arrayOfObject.length; j++)
    {
      paramArrayOfInt[j] = arrayOfInt[i];
      paramArrayOfObject[j] = arrayOfObject[i];
      i++;
    }
  }
  
  public static int[] getIntArray(String paramString)
  {
    int[] arrayOfInt = null;
    try
    {
      BufferedReader localBufferedReader = new BufferedReader(new FileReader(paramString));
      String str1 = localBufferedReader.readLine();
      StringTokenizer localStringTokenizer = new StringTokenizer(str1);
      int i = localStringTokenizer.countTokens();
      int j = 0;
      arrayOfInt = new int[i];
      while (localStringTokenizer.hasMoreTokens())
      {
        String str2 = localStringTokenizer.nextToken();
        if (!str2.startsWith("#")) {
          arrayOfInt[(j++)] = Integer.parseInt(str2);
        }
      }
      if (j != i) {
        arrayOfInt = trim(arrayOfInt, j);
      }
      return arrayOfInt;
    }
    catch (Exception localException)
    {
      localException.printStackTrace();
    }
    return null;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\util\ArrayLib.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */